/**
  * Submits the startegy definition form
  */

function submitStrategyForm(formObj)
{
   if(!validateName(formObj.name.value))
   {
      alert($i18n("fcm.sq.strategy.js.submitStrategyForm.alert0.txt"));
      formObj.name.select();
      formObj.name.focus();
      return false;
   }

   if(!validateDescription(formObj.description.value))
   {
      alert($i18n("fcm.sq.strategy.js.submitStrategyForm.alert1.txt"));
      formObj.description.select();
      formObj.description.focus();
      return false;
   }

   // Inactive status check
   if(formObj.status[1].checked && isItemAssigned(queueList))
   {
      if(!confirm($i18n("fcm.sq.strategy.js.submitStrategyForm.confirm0.0.txt")+"\n\n"+
                  $i18n("fcm.sq.strategy.js.submitStrategyForm.confirm0.1.txt")))
         return false;
   }

   // Make sure outbound strategies have one or both direct/priority servicing checked
   if(formObj.type.value == 'OUT')
   {
      if(!formObj.priorityServiceMode.checked && !formObj.directServiceMode.checked)
      {
         alert($i18n("fcm.sq.strategy.js.submitStrategyForm.alert2.txt"));
         formObj.priorityServiceMode.focus();
         return false;
      }

      // notify if active strategy has no users.
      if(formObj.status[0].checked && !isItemAssigned(userData))
      {
			if(!confirm($i18n("fcm.sq.strategy.js.submitStrategyForm.confirm1.0.txt")+"\n"+
				    $i18n("fcm.sq.strategy.js.submitStrategyForm.confirm1.1.txt")+"\n\n"+
				    $i18n("fcm.sq.strategy.js.submitStrategyForm.confirm1.2.txt")))
				return false;
      }
   }

   //getElement("saveButton").disabled = true;

   postAssignment(analystList,'analystIdsStr');
   postAssignment(queueList,'queueIdsStr');
   postAssignment(memoData,'predefinedMemosStr');
   postAssignment(scriptData,'callScriptsStr');

   // Only outbound strategies have these properties
   if(formObj.type.value == 'OUT')
   {
      postAssignment(userData,'usersStr');

      checkServiceMode(formObj);
   }
   else
   {
      formObj.serviceMode.value = "I";
   }

	setBusy();

}

function checkServiceMode(formObj)
{
   if( formObj.directServiceMode.checked &&
       formObj.priorityServiceMode.checked )
   {
      formObj.serviceMode.value = "A";
   }
   else if(formObj.priorityServiceMode.checked)
   {
      formObj.serviceMode.value = formObj.priorityServiceMode.value;
   }
   else if(formObj.directServiceMode.checked)
   {
      formObj.serviceMode.value = formObj.directServiceMode.value;
   }
   else
   {
      formObj.serviceMode.value = "I";
   }
}

/**
  * Builds the posted element string value based on js array
  *
  * @returns true if assignment existed, otherwise false.
  */
function postAssignment(arrayList,eleName)
{
   var assignedElement = document.createElement("input");
   assignedElement.type = "hidden";
   assignedElement.name = eleName;
   assignedElement.value = "";

   for(var i = 0, len = arrayList.length; i < len; i++)
   {
      var item = arrayList[i];
      if(item.isAssigned)
      {
         assignedElement.value += item.id+":";
      }

   }

   if(assignedElement.value.length > 0)
   {
      document.strategyForm.appendChild(assignedElement);
      return true;
   }

   return false;

}

function isItemAssigned(arrayList)
{
   for(var i = 0, len = arrayList.length; i < len; i++)
   {
      if(arrayList[i].isAssigned)
      {
         return true;
      }
   }
   return false;
}

var _prevStrategyType = "";

function enableOutboundProperties(formObj, sltbx)
{
   var strategyType = sltbx[sltbx.selectedIndex].value;
   var label, indx;
   if(strategyType == "OUT")
   {
      formObj.directServiceMode.disabled = false;
      formObj.priorityServiceMode.disabled = false;

      label = document.getElementById("configAddCallScriptsLabel");
      indx = label.innerHTML.indexOf(" "+$i18n("fcm.sq.strategy.notApplicable.txt"));
      if(indx >= 0)
         label.innerHTML = label.innerHTML.substring(0,indx);

      label = document.getElementById("configAddUsersLabel");
      indx = label.innerHTML.indexOf(" "+$i18n("fcm.sq.strategy.notApplicable.txt"));
      if(indx >= 0)
         label.innerHTML = label.innerHTML.substring(0,indx);

      enableAssignmentListboxes(formObj,['Users','CallScripts'],true);
   }
   else
   {
      if(_prevStrategyType === "OUT" && !$(sltbx).data("messageWarningShown"))
      {
         alert($i18n("fcm.sq.strategy.js.enableOutboundProperties.alert0.txt"));
         $(sltbx).data("messageWarningShown",true);
      }


      formObj.directServiceMode.disabled = true;
      formObj.priorityServiceMode.disabled = true;

//      label = document.getElementById("configAddCallScriptsLabel");
//      indx = label.innerHTML.indexOf(" "+$i18n("fcm.sq.strategy.notApplicable.txt"));
//      if(indx < 0)
//         label.innerHTML += " "+$i18n("fcm.sq.strategy.notApplicable.txt");

      label = document.getElementById("configAddUsersLabel");
      indx = label.innerHTML.indexOf(" "+$i18n("fcm.sq.strategy.notApplicable.txt"));
      if(indx < 0)
         label.innerHTML += " "+$i18n("fcm.sq.strategy.notApplicable.txt")

		// 8/1/06 Now allow any strategy to have call scripts at mgr's discretion
//      enableAssignmentListboxes(formObj,['Users','CallScripts'],false);
		enableAssignmentListboxes(formObj,['Users'],false);
   }

	// don't allow queues to be added or removed from the inbound strategy
   if(strategyType == "INB")
   {
   	// prevent changes to assigned queues
   	getElement("addQueuesAnchor").disabled = true;
   	getElement("addQueuesAnchor").onclick = alwaysReturnFalse;
   	// no longer have this button 7/24/06
//   	getElement("removeQueuesAnchor").disabled = true;
//   	getElement("removeQueuesAnchor").onclick = alwaysReturnFalse;

   	// must be readonly to submit via save
   	formObj.name.readOnly= true;
   	formObj.description.readOnly = true;

   	// disable the INACTIVE status of this strategy.  It is always ACTIVE
   	formObj.status[1].disabled = true;
   }

   _prevStrategyType = strategyType;
}

function enableAssignmentListboxes(formObj,nameIds, enabled)
{
	if(!nameIds) return;

	for(var i = 0 ; i < nameIds.length ;i++)
	{
		var name = nameIds[i];
		formObj.elements["unassigned"+name+"Listbox"].disabled = !enabled;
		formObj.elements["assigned"+name+"Listbox"].disabled = !enabled;
		// deselect any items
		formObj.elements["unassigned"+name+"Listbox"].selectedIndex = -1;
		formObj.elements["assigned"+name+"Listbox"].selectedIndex = -1;

		//disable buttons for dropdown listbox
		getElement("add"+name+"Anchor").disabled = !enabled;
		getElement("remove"+name+"Anchor").disabled = !enabled;

	}
}

function resetTeamSelection(teamSlt,lbx)
{
   teamSlt.selectedIndex = 0;
   showUnassignedRepsByTeam(lbx,teamSlt.options[0].value);
}

function showUnassignedRepsByTeam(lbx,selectedTeamId)
{
   var valueArray = new Array();
   var labelArray = new Array();

   if(selectedTeamId == -1)// show all unassigned reps
   {
      loadListboxByAssignment(userData,lbx.parentNode.id,false);
   }
   else
   {
      for(var i = 0, len = userData.length; i < len; i++)
      {
         if(!userData[i].isAssigned && userData[i].teamId == selectedTeamId)
         {
            labelArray.push(userData[i].label);
            valueArray.push(i);
         }
      }
      loadListbox(lbx.parentNode.id,valueArray,labelArray);

      // select all members for this team by default
      // to do this we have to get a "fresh" reference to the listbox
      // since it was just repopulated using innerHTML
      for(var i = 0; i < document.forms.length; i++)
      {//which form is it?
         if(document.forms[i].elements[lbx.name])
            lbx = document.forms[i].elements[lbx.name];
      }
      // select all options
      for(var i = 0; i < valueArray.length; i++)
         lbx.options[i].selected = true;
   }

}

function modifySelectionChoices(obj, warningMessage){

	var showWarning = $(obj).data("showWarning");
	if(showWarning === undefined || showWarning === true)
	{
		var choice = confirm(warningMessage);
		$(obj).data("showWarning",!choice)
		if(choice === false)
		{
			$(obj).find('option').each(function(){
				this.selected = this.defaultSelected;
			})
			return;
		}
	}

	//Clear out current array so we can rebuild it with new business unit
	teamData=[];
	groupData=[];
	userData=[];
	scriptData=[];
	memoData=[];

	var bu=document.getElementById("buId");
	var buVal = parseInt(bu.options[bu.selectedIndex].value);

	//TEAM LIST
	for(var i = 0; i < teamList.length; i++){
		if(teamList[i].bu === buVal || teamList[i].id===-1){
		   teamData.push(teamList[i]);
		}
	}
	loadSelectBox(teamData,'teams');

	//GROUP LIST
	for(var i = 0; i < groupList.length; i++){
		if(groupList[i].bu === buVal){
		   groupData.push(groupList[i]);
		}
	}

	document.getElementById("groupId").options.length=groupData.length;
	document.getElementById("groupId").options[0] = new Option("None selected", "");
	var groupSelected = 0;
	for (var i=0; i<groupData.length; i++) {
		document.getElementById("groupId").options[i+1] = new Option(groupData[i].name, groupData[i].id);
		if(groupData[i].isSelected)
			groupSelected = i+1;
	}
	document.getElementById("groupId").options[groupSelected].selected = true;

	//USERS
	for(var i = 0; i < userList.length; i++){
	      //userList[i].isAssigned=(false);
	      for(var j=0;j<userList[i].bu.length;j++){
		if(userList[i].bu[j] == buVal){
		   userData.push(userList[i]);
		}
	      }
	}
	loadListboxByAssignment(userData,'assignedUsersContainer',true);
	loadListboxByAssignment(userData,'unassignedUsersContainer',false);

	var assignedSize = 0; // keeps track of the number of assigned items
	//CALL SCRIPTS
	_defaultTemplateIds[_callScriptType] = -101;
	for(var i = 0; i < scriptList.length; i++){
		//scriptList[i].isAssigned=(false);
		if(scriptList[i].bu === buVal){
		   scriptData.push(scriptList[i]);
		   if(scriptList[i].isAssigned) assignedSize++;
		   if(scriptList[i].isDefault)
		   {
			   _defaultTemplateIds[_callScriptType] = (assignedSize-1);
		   }
		}
	}
	loadListboxByAssignment(scriptData,'assignedCallScriptsContainer',true);
	loadListboxByAssignment(scriptData,'unassignedCallScriptsContainer',false);

	if(_defaultTemplateIds[_callScriptType] !== -101)
	{
		var $opt = $('#assignedCallScriptsContainer select option:eq('+_defaultTemplateIds[_callScriptType]+')');
		if($opt.length > 0) // RAPTOR-2399
			populateDefaultFields(_callScriptType,$opt[0])
	}
	else
		$('#defaultCallScriptDisplay').text('');

	//MEMOS
	_defaultTemplateIds[_memoType] = -101;
	assignedSize = 0;
	for(var i = 0; i < memoList.length; i++){
		//memoList[i].isAssigned=(false);
		if(memoList[i].bu === buVal){
		   memoData.push(memoList[i]);
		   if(memoList[i].isAssigned) assignedSize++;
		   if(memoList[i].isDefault)
			   _defaultTemplateIds[_memoType] = assignedSize -1;
		}
	}
	loadListboxByAssignment(memoData,'assignedMemosContainer',true);
	loadListboxByAssignment(memoData,'unassignedMemosContainer',false);
	if(_defaultTemplateIds[_memoType] !== -101)
	{
		var $opt = $('#assignedMemosContainer select option:eq('+_defaultTemplateIds[_memoType]+')');
		if($opt.length > 0) // RAPTOR-2399
			populateDefaultFields(_memoType,$opt[0])
	}
	else
		$('#defaultMemoDisplay').text('');

}

function modifyAnalystSelection(obj, analystListMap, warningMessage)
{
	var showWarning = $(obj).data("showWarning");
	if(showWarning === undefined || showWarning === true)
	{
		var choice = confirm(warningMessage);
		$(obj).data("showWarning",!choice)
		if(choice === false)
		{
			$(obj).find('option').each(function(){
				this.selected = this.defaultSelected;
			})
			return;
		}
	}

	// Clear out current array so we can rebuild it with new grid template
	analystList=[];

	var gridTemplate = document.getElementById("gridTemplateId");
	var gridTemplateVal = "T" + gridTemplate.options[gridTemplate.selectedIndex].value;

	// Analyst
	if(analystListMap[gridTemplateVal] != undefined && analystListMap[gridTemplateVal].length!= 0 )
	{
		analystList = analystListMap[gridTemplateVal];
		// alert("analystListMap 1: "+ analystListMap[gridTemplateVal][0].id);
	} else {
		var $selectTag = $('#assignedAnalystsContainer'+' select');
		$selectTag.html('');
	}

    loadListboxByAssignment(analystList,'assignedAnalystsContainer',true);
    loadListboxByAssignment(analystList,'unassignedAnalystsContainer',false);
}


var _callScriptType=0;
var _memoType=1;
var _defaultTemplateIds = [-101,-101];

function populateDefaultFields(templateType, defaultItem){

	//CHANGE THE COLOR OF THE OPTION TO INDICATE IT IS DEFAULT
	defaultItem.className = "defaultTemplateItem";

	if(templateType==0){
		var item = scriptData[defaultItem.value];
		document.strategyForm.defaultCallScript.value=item.id;
		$('#defaultCallScriptDisplay').text(defaultItem.text);

	}
	else if(templateType==1){
		var item = memoData[defaultItem.value];
		document.strategyForm.defaultPredefinedMemo.value=item.id;
		$('#defaultMemoDisplay').text(defaultItem.text);
	}

}

function setAsDefaultItem(evt, listBoxName)
{
	//DETERMINE THE TEMPLATE TYPE
	if (listBoxName.indexOf("Scripts")>0) var templateType=_callScriptType;
	else var templateType=_memoType;


	//DETERMINE WHICH LISTBOX IS MAKING THE CALL
	var caller = document.getElementsByName(listBoxName)[0];
	//IF NO SELECTIONS ARE MADE RETURN
	if(caller.selectedIndex == -1) return;

	for(var i = 0; i < caller.options.length; i++)
	{
		//DETERMINE THE POSITION OF THE OPTION
		var defaultItem = caller.options[i];
		//IF OPTION IS THE SELECTED OPTION
		if(i == caller.selectedIndex)
		{
			//POPULATE _defaultTemplateIds[templateType] WITH THE POSITION OF THE SELECTED OPTION
			_defaultTemplateIds[templateType] = parseInt(defaultItem.value);

			//POPULATE THE HIDDEN FIELD defaultEmail with the templateId-THIS WILL BE SAVED IN THE queueForm
			//DISPLAY THE DEFAULT TEMPLATE WITH THE TEMPLATE NAME
			populateDefaultFields(templateType, defaultItem);

		}
		//TURN THE PREVIOUS DEFAULT TO REGULAR COLOR
		else if(defaultItem.className == "defaultTemplateItem")
		{
			defaultItem.className = "";

		}
	}
	//DESELECT ALL OPTIONS
	caller.selectedIndex = -1;
}

//CALLED WHEN A USER ASSIGNS NEW TEMPLATES OR REMOVES TEMPLATES
function selectDefaultItem(evt,listBoxName)
{

	//DETERMINE THE TEMPLATE TYPE
	if (listBoxName.indexOf("Scripts")>0) var templateType=_callScriptType;
	else var templateType=_memoType;


	//DETERMINE WHICH LISTBOX IS MAKING THE CALL
	var caller = document.getElementsByName(listBoxName)[0];
	//INITIALIZE EXISTS FLAG TO FALSE
	var exists = false;

	//LOOP THROUGH ALL THE LISTBOX OPTIONS
	for(var i = 0; i < caller.options.length; i++)
	{
		var defaultItem = caller.options[i];
		var len=caller.options.length;
		defaultItem.className=="";

		//IF WE HAD ALREADY SAVED A DEFAULT
		//OR
		//IF THE POSITION OF THE CURRENT OPTION IS THE SAME AS THE PREVIOUS DEFAULT TEMPLATE
		if(parseInt(defaultItem.value) === _defaultTemplateIds[templateType] ){

			//alert("THE PREVIOUS DEFAULT TEMPLATE STILL EXISTS: " + defaultItem.value);

			//CHANGE THE THE DEFAULT FIELDS
			populateDefaultFields(templateType, defaultItem);

			//SET THE EXIST VALUE TO TRUE
			exists = true;
		}
		if(!exists && _defaultTemplateIds[templateType]>=0){//THE PREVIOUS DEFAULT TEMPLATE HAS BEEN REMOVED
			if(_defaultTemplateIds[templateType]<parseInt(defaultItem.value) || i==len-1){
				//alert("THE DEFAULT DOES NOT EXIST ANYMORE.  TAKE THE OPTION THAT WAS IN THE PREVIOUS DEFAULTS POSITION OR IF IT DOESN'T EXIST TAKE THE LAST ONE: " + defaultItem.value);

				_defaultTemplateIds[templateType]=parseInt(defaultItem.value);

				//SET NEW DEFAULT VALUES
				populateDefaultFields(templateType, defaultItem);

				//STOP LOOPING
				break;
			}
		}
	}
	if(!exists){//NO PREVIOUS DEFAULT OR NO OPTIONS IN LISTBOX

		if (len>0){//THERE ARE OPTIONS IN THE LISTBOX
			//NO PREVIOUS DEFAULT TEMPLATE, SO WE SET DEFAULT TO THE FIRST OPTION ON THE LIST
			if(_defaultTemplateIds[templateType]<0){
				//alert("THERE WAS NO PREVIOUS DEFAULT TEMPLATE SO WE SET IT TO THE FIRST ONE ON THE LIST");
				var defaultItem=caller.options[0];
				_defaultTemplateIds[templateType] = parseInt(defaultItem.value);
				populateDefaultFields(templateType,defaultItem);
			}


		}
		else{//THERE ARE NO OPTIONS IN THE LISTBOX
			//alert("THERE ARE NO OPTIONS IN THE LISTBOX");
			_defaultTemplateIds[templateType]=-101;

			if(templateType==0){
				document.strategyForm.defaultCallScript.value="";
				document.getElementById('defaultCallScriptDisplay').innerHTML ="";
			}
			if(templateType==1){
				document.strategyForm.defaultPredefinedMemo.value="";
				document.getElementById('defaultMemoDisplay').innerHTML ="";
			}

		}
	}
}

function loadSelectBox(srcArrayListName, selectBox){

	var arrayList = srcArrayListName;
	var $selectBox = $('#'+selectBox);
	$selectBox.find('option').remove();
	var options = [];
	for(var i = 0, len = arrayList.length; i < len; i++)
	   {
		options.push('<option value="'+arrayList[i].id+'">'+arrayList[i].label+'</option>');
	}
	$selectBox.append(options.join(''));
}