var ENTER_KEY = 13;  // 13 is ascii for enter key
var activeTab = new Array('searchByEntity');
var matchTypeFields = ['lastNameMatchType','addressMatchType'];

function initSearch()
{
	$(':radio[name^="returnType"]').click(rememberReturnTypeSelection);
	$(':radio[name="searchTypeRadioDemo"]').click(rememberDemoSearchTypeSelection);

	var entityType = getCookie('entitySearchTabReturnType','C');
//	$(':radio[name="returnTypeEntity"][value="'+entityType+'"]').prop('checked',true);
	var initEntitySel='input[name="returnTypeEntity"][value=' + entityType + ']';

	//entityType = getCookie('acctSearchTabReturnType','A');
	//$(':radio[name="returnTypeAcct"][value="'+entityType+'"]').prop('checked',true);

	entityType = getCookie('demoSearchTabReturnType','X');
	$(':radio[name="returnTypeDemo"][value="'+entityType+'"]').prop('checked',true);

	var demoSearchType = getCookie('demoSearchTabSearchType','personalId');
	$(':radio[name="searchTypeRadioDemo"][value="'+demoSearchType+'"]').click();

	var searchType = getCookie('inboundSearchTab','searchByEntity');
	$('input:hidden[name="searchType"]').val(searchType);
	swapGridContents(searchType,1);

	$('input[name="returnTypeEntity"]').click(function (e) {
		var selection = e.target.value;
		var sel = $('select[name="entityType"]');

		// clear previous options
		$('option', sel).remove();

		// create searchBy options selector based on current selection and its entity type hierarchy
		var z = $(this).attr("entityTypes").split(" ");
//		var x= 'option[entityTypes*="' + selection + '"]';
		var x= 'option[value="' + selection + '"]';
		for (var index=1; index < z.length; index++ )
		{
		 	if ( z[index] == "" ) continue;
			x += ', option[value="' + z[index] + '"]';
		};
		// add the options to the select, and set to last picked option
		$(x, '#entitySearchByOptions').each( function () { sel.append($(this).prop('outerHTML') + $(this).prop('text'));});
		sel.val(getCookie('entitySearchTabEntityTypeSelected', selection));
	});

	$('select[name="entityType"]')
		.change(function () { setCookie('entitySearchTabEntityTypeSelected',$(this).val()); })
//		.resize(function () { $('#searchBySection').offset({left:($(this).offset().left + $(this).outerWidth() + 2)}); });

	$(initEntitySel).click();
}

function swapGridContents(gridName,gridNum)
{
	prev=activeTab[gridNum-1];
	$('#'+prev+"Grid").hide();
//	$('#'+prev + "Tab").attr('className',"normal");
	$('#'+prev + "Tab").removeClass("current");
	$('#'+gridName + "Grid").show()
//	$('#'+gridName + "Tab").attr('className',"current");
	$('#'+gridName + "Tab").addClass("current");
	window.focus();
	activeTab[gridNum-1]=gridName;
	$("input:hidden[name='searchType']").val(gridName);
	setCookie('inboundSearchTab',gridName);

}

function rememberReturnTypeSelection()
{
	var $radio = $(this);

	var name = $radio.attr('name');
	var value = $radio.val();  // RAPTOR-2399
	var tab = name.substring(10).toLowerCase();
	setCookie(tab+'SearchTabReturnType',value);
}

function rememberDemoSearchTypeSelection()
{
	var $radio = $(this);

	var name = $radio.attr('name');
	var value = $radio.val();  // RAPTOR-2399
	setCookie('demoSearchTabSearchType',value);

	toggleSearchFields(value);
}

function toggleSearchFields(sel)
{
	if (sel == 'personalId')
	{
		enable('personalId');
		disable('lastName');
		disable('phone');
		disable('address');
		disable('city');
		disable('state');
		disable('postalCode');
		disable('email');
		disableFields(matchTypeFields);
	}
	else if(sel == 'lastName') // last name or phone search
	{
		enable('lastName');
		enable('phone');
		enable('address');
		enable('city');
		enable('state');
		enable('postalCode');
		enable('email');
		enableFields(matchTypeFields);
		disable('personalId');
	}
}

function emptyOtherSearchFields(sel)
{
	if(sel == 'entityNum')
	{
//		resetAccountSearchFields();
		resetDemoSearchFields(true, true, true);
		resetAlertSearchFields(true, true, true);
	}
//	else if (sel == 'accountNum')
//	{
//		resetEntitySearchFields();
//		resetDemoSearchFields(true, true, true);
//		resetAlertSearchFields(true, true, true);
//	}
	else if(sel == 'alertId')
	{
		resetEntitySearchFields();
//		resetAccountSearchFields();
		resetDemoSearchFields(true, true, true);
		resetAlertSearchFields(false, true, false);
	}
	else if (sel == 'personalId')
	{
		resetEntitySearchFields();
//		resetAccountSearchFields();
		resetDemoSearchFields(false, false, false);
		resetAlertSearchFields(true, true, true);
	}
	else if (sel == 'lastName') // last name or phone search
	{
		resetEntitySearchFields();
//		resetAccountSearchFields();
		resetAlertSearchFields(true, true, true);
		document.getElementById('personalId').value = '';
	}
}

function resetEntitySearchFields()
{
	$(':text[name="entityNum"]').val('');
	$(':radio[name="returnTypeEntity"]').prop('disabled',true);
}

//function resetAccountSearchFields()
//{
//	$(':text[name="accountNum"]').val('');
//	$(':radio[name="returnTypeAcct"]').prop('disabled',true);
//}

function resetDemoSearchFields(includingPersonalId, includingReturnTypes, includingSearchTypes) {
	if(includingPersonalId)
	{
		$(':text[name="personalId"]').val('');
	}
	document.getElementById('lastName').value = '';
	document.getElementById('phone').value = '';
	document.getElementById('address').value = '';
	document.getElementById('city').value = '';
	document.getElementById('state').value = '';
	document.getElementById('postalCode').value = '';
	document.getElementById('email').value = '';

	if (includingReturnTypes)
	{
		$(':radio[name="returnTypeDemo"]').prop('disabled',true);
	}

	if (includingSearchTypes)
	{
		$(':radio[name="searchTypeRadioDemo"]').prop('disabled',true);
	}
}

function resetAlertSearchFields(includingAlertId, includingReturnTypes, includingSearchTypes) {
	if(includingAlertId) {document.getElementById('alertId').value = '';}

}

function disable(elName)
{
	document.getElementById(elName).disabled=true;
	if(document.getElementById(elName).type != 'radio') {
		document.getElementById(elName).style.backgroundColor='silver';
	}
}

function disableFields(elemIdArray) {
	for(var jj=0; jj<elemIdArray.length; jj++) {
		disable(elemIdArray[jj]);
	}
}

function enableFields(elemIdArray) {
	for(var jj=0; jj<elemIdArray.length; jj++) {
		enable(elemIdArray[jj]);
	}
}

function enable(elName)
{
	document.getElementById(elName).disabled=false;
	if(document.getElementById(elName).type != 'radio') {
		document.getElementById(elName).style.backgroundColor='white';
	}
}

function submitSearch()
{
	setBusy('mainDiv');
	document.searchForm.submit();
}

function searchByEntity()
{
	var entityNum = document.searchForm.entityNum.value;
	entityNum = trim(entityNum);

	var entityType = $(document.searchForm.entityType).find('option:selected').val();
	var entityTypeText=$(document.searchForm.entityType).find('option:selected').attr('label');

	if (isEmpty(entityNum))
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert15.fmt.txt",[entityTypeText]));
		return;
	}
	var minLength = $('input:hidden[name="firstNMinimum_'+entityType+'"]').val();
	if(entityNum.length < minLength) {
		alert($i18n("fcm.inboundSearch.js.checkKey.alert1.fmt.txt",[minLength]));
		return;
	}

	emptyOtherSearchFields('entityNum');
	submitSearch();
}

/*function searchByAccount()
{
	var accountNum = document.searchForm.accountNum.value;
	accountNum = trim(accountNum);

	if (accountNum.length == 0)
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert16.txt"));
		return;
	}

	if(accountNum.length < document.searchForm.firstNAccountMinimum.value )
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert2.fmt.txt",[document.searchForm.firstNAccountMinimum.value]));
		return;
	}

	emptyOtherSearchFields('accountNum');
	if($(':radio:checked[name="returnTypeAcct"]').val() === 'A')
		$(':text[name="entityNum"]').val(accountNum);

	submitSearch();
}*/

function isEnabled(elName)
{
	return !document.getElementById(elName).disabled;
}

function searchByDemographicInfo()
{

	if(isEnabled('personalId'))
	{
		var personalId = document.searchForm.personalId.value;
		personalId = trim(personalId);

		if(isEmpty(personalId))
		{
			alert($i18n("fcm.inboundSearch.js.checkKey.alert5.txt"));
			return;
		}

		if(personalId.length < 4) // hard code it to 4
		{
			alert($i18n("fcm.inboundSearch.js.checkKey.alert17.fmt.txt",[4]));
			return;
		}

		emptyOtherSearchFields('personalId');
		//if($(':radio:checked[name="returnTypeDemo"]').val() === 'X')
			//$(':text[name="entityNum"]').val(personalId);
	}
	else
	{
		var lastName = document.searchForm.lastName.value;
		lastName = trim(lastName);

		var phone = document.searchForm.phone.value.replace(/-/g,'');
		phone = phone.replace(/\(/g, '');
		phone = phone.replace(/\)/g, '');
		phone = phone.replace(/\+/g, '');
		phone = trim(phone);

		var postalCode = document.searchForm.postalCode.value;
		postalCode = trim(postalCode);

		var email = document.searchForm.email.value;
		email = trim(email);

		if(isEmpty(lastName) &&
			isEmpty(postalCode) &&
			isEmpty(phone) &&
			isEmpty(email))
		{
			alert($i18n("fcm.inboundSearch.js.checkKey.alert18.txt"));
			return;
		}

		// Most postal codes are numeric, but the UK uses alphanumeric codes.  No postal codes are less than 3 alphanumeric characters
		//  see http://en.wikipedia.org/wiki/Postal_Code
		if(postalCode.length > 0 && !isValidUSZipCode(postalCode))
		{
			if(postalCode.length < 3)
			{
				alert($i18n("fcm.inboundSearch.js.checkKey.alert6.txt"));
				return;
			}
		}

		if(phone.length > 15)
		{
			alert($i18n("fcm.inboundSearch.js.checkKey.alert7.txt"));
			return
		}

		if (email.length > 50)
		{
			alert($i18n("fcm.inboundSearch.js.checkKey.alert8.txt"));
			return;
		}

		emptyOtherSearchFields('lastName');
	}

	submitSearch();
}

function searchByAlert()
{
	var alertId = document.searchForm.alertId.value;
	alertId = trim(alertId);

	// Cannot be empty
	if (isEmpty(alertId))
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert3.txt"));
		return;
	}

	// Cannot be negative
	if (alertId < 0)
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert21.txt"));
		return;
	}

	// Must be an integer
	if (!isInteger(alertId))
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert4.txt"));
		return;
	}

	// Must be less than or equal to 9223372036854775807 (maximum Long = 2^63 - 1)
	var maxAlertId = '9223372036854775807';
	if (alertId.length > maxAlertId.length)
	{
		alert($i18n("fcm.inboundSearch.js.checkKey.alert22.txt"));
		return;
	}
	else if (alertId.length == maxAlertId.length)
	{
		var done = false;
		for(var i =0; i < alertId.length && !done; i++)
		{
			if (alertId.charAt(i) > maxAlertId.charAt(i))
			{
				alert($i18n("fcm.inboundSearch.js.checkKey.alert22.txt"));
				return;
			}

			if (alertId.charAt(i) < maxAlertId.charAt(i))
			{
				done = true;
			}
		}
	}

	emptyOtherSearchFields('alertId');

	submitSearch();
}


function checkKey(searchType)
{
	var keycode = window.event.keyCode;
	if(keycode != ENTER_KEY)
		return;
	else
	{
		if(searchType == 'searchByEntity')
			searchByEntity();
		/*else if(searchType == 'searchByAccount')
			searchByAccount();*/
		else if(searchType ==  'searchByAlert')
			searchByAlert();
		else if(searchType == 'searchByDemographicInfo')
			searchByDemographicInfo();
	}
}

// Need validation scheme for postal code in other countries
function isValidUSZipCode(str) {
	var zipcodeRegex = /^[0-9]{5}(-?[0-9]{4})?$/;
	if(str.length <=10 && str.match(zipcodeRegex)) {
		return true;
	}
	return false;
}

function isAlphaNumeric(str) {
	var number = /[0-9]+/;
	var alpha = /[A-Za-z]+/;
	str = str.replace(number,"").replace(alpha,"");
	if(str.length == 0)
		return true;
	return false;
}

function isInteger(str) {
	var searchStr = /[0-9]+/;
	var replaceStr = "";
	str = str.replace(searchStr,replaceStr);
	if (str.length == 0) {
		return true;
	}
	else
		return false;
}

function updateEntitySearchTypes(e)
{
	var $labels = $('label[entityTypes]');

	$labels.hide();
	$('#returnTypeLabel').hide();

	var $selectBox = $(this);
	var selectedEntityType = $selectBox.find(':selected').val();

	setCookie('entitySearchTabEntityTypeSelected',selectedEntityType);

	var $filteredLabels = $labels.filter('[entityTypes~='+selectedEntityType+']');
	if($filteredLabels.length > 1) // RAPTOR-2399
	{
		$('#returnTypeLabel').show();
		$filteredLabels.show();

		var selectedSearchType = $selectBox.find(':selected').data('selectedSearchType');

		if(selectedSearchType)
		{
			var $radiobox = $filteredLabels.find(":radio[value='"+selectedSearchType+"']");
			if($radiobox.length === 1) // RAPTOR-2399
				$radiobox.prop('checked',true);
			else
				$filteredLabels.first().find(":radio").click();
		}
		else
		{// does this check defaultcheck property on the radio?
			if($filteredLabels.find(":radio:checked").length === 0) // RAPTOR-2399
				$filteredLabels.first().find(":radio").click()
		}

		$selectBox.find(':selected').data('selectedSearchType', $filteredLabels.find(':radio:checked').val());
	}
	else // ensure that the return type is set to itself for search to work
	{
		$(':radio[name="returnTypeEntity"][value="'+selectedEntityType+'"]').click();
	}

}