// mix some guided view helper functions into sas.fscf if they are not already there
// loaded (only) by guided views, such as Rules and Explore, that need them
if (!sas.fscf.getQueryUrl) {
		sas.fscf.getQueryUrl = function(type, schema, q, fields) {
        	// type should be "search"
        	if (type == undefined || type == null) {
        		type = "search";		// default to "search"
        	}
        	var urlSegments = [];
        	urlSegments[urlSegments.length] = "rest/transactions/" + type + "?";
        	if (schema != null && schema != undefined) {
            	urlSegments[urlSegments.length] = "schema=" + encodeURIComponent(schema);
        		try {
        			urlSegments[urlSegments.length] = "&tsperiod=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsperiod());        		
        		} catch (e) {}
        		try {
        			if (sas.fscf.getCurrentPageView().getGuidedView().getTsoffset() != null)  {
        				urlSegments[urlSegments.length] = "&tsoffset=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsoffset());
        			}
        		} catch (e) {}
            	urlSegments[urlSegments.length] = "&";
        	}
        	urlSegments[urlSegments.length] = "q=" + q;
        	if ($.isArray(fields) && fields.length > 0) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(fields.join(","));
        	} else if (fields && fields.length > 0) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(fields);
        	}
        	if (schema == null || schema == undefined) {
	        	urlSegments[urlSegments.length] = "&name=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.transactionTypeId);
	        	urlSegments[urlSegments.length] = "&scope=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId);
        	}
        	return urlSegments.join("");
        };
        sas.fscf.defaultNoOfGroups = 10;	//should be a multiple of 5
		sas.fscf.getQueryObject = function(type, schema, q, fields, variableTypes, froms, tos, g_froms, g_tos, g_bys) {
        	// type should be "facets", "risk", "fraud", etc.
        	if (type == undefined || type == null) {
        		type = "risk";		// default to "risk"
        	}
        	var urlSegments = [];
        	urlSegments[urlSegments.length] = "rest/transactions/" + type + "?";
        	if (schema != null && schema != undefined) {
            	urlSegments[urlSegments.length] = "schema=" + encodeURIComponent(schema);
        		try {
        			urlSegments[urlSegments.length] = "&tsperiod=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsperiod());        		
        		} catch (e) {}
        		try {
        			if (sas.fscf.getCurrentPageView().getGuidedView().getTsoffset() != null)  {
        				urlSegments[urlSegments.length] = "&tsoffset=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsoffset());
        			}
        		} catch (e) {}
            	urlSegments[urlSegments.length] = "&";
        	}
        	urlSegments[urlSegments.length] = "q=" + q;
        	if (schema == null || schema == undefined) {
	        	urlSegments[urlSegments.length] = "&name=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.transactionTypeId);
	        	urlSegments[urlSegments.length] = "&scope=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId);
        	}
			var obj = {};
        	obj.url = urlSegments.join("");
        	obj.data = {};
        	obj.data.aggs = {};
        	if (!$.isArray(fields)) {
        		fields = [fields];
        	}
        	if (!$.isArray(variableTypes)) {
        		variableTypes = [variableTypes];
        	}
        	if (!$.isArray(froms)) {
        		froms = [froms];
        	}
        	if (!$.isArray(tos)) {
        		tos = [tos];
        	}
        	if (!$.isArray(g_froms)) {
        		g_froms = [g_froms];
        	}
        	if (!$.isArray(g_tos)) {
        		g_tos = [g_tos];
        	}
        	if (!$.isArray(g_bys)) {
        		g_bys = [g_bys];
        	}
        	for (var i = 0; i < fields.length; i++) {
        		if (!fields[i] || fields[i].length == 0) {
        			continue;
        		}
        		obj.data.aggs[fields[i]] = {};
        		if (variableTypes[i] == "Numeric" || variableTypes[i] == "Currency") {
        			obj.data.aggs[fields[i]].range = {};
        			obj.data.aggs[fields[i]].range.field = fields[i];
        			obj.data.aggs[fields[i]].range.ranges = [];
        			if (!(isNaN(froms[i]) && isNaN(tos[i]))) {
            			if (froms[i] == tos[i]) {
                			obj.data.aggs[fields[i]].range.ranges[0] = {};
                			obj.data.aggs[fields[i]].range.ranges[0].displayName = "n > " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[0].from = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[0].fromIncl = false;
                			obj.data.aggs[fields[i]].range.ranges[1] = {};
                			obj.data.aggs[fields[i]].range.ranges[1].displayName = "n >= " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[1].from = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[2] = {};
                			obj.data.aggs[fields[i]].range.ranges[2].displayName = "n = " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[2].from = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[2].to = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[2].toIncl = true;
                			obj.data.aggs[fields[i]].range.ranges[3] = {};
                			obj.data.aggs[fields[i]].range.ranges[3].displayName = "n <= " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[3].to = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[3].toIncl = true;
                			obj.data.aggs[fields[i]].range.ranges[4] = {};
                			obj.data.aggs[fields[i]].range.ranges[4].displayName = "n < " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[4].to = tos[i];
            			} else {
                			obj.data.aggs[fields[i]].range.ranges[0] = {};
                			obj.data.aggs[fields[i]].range.ranges[0].displayName = "n > " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[0].from = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[0].fromIncl = false;
                			obj.data.aggs[fields[i]].range.ranges[1] = {};
                			obj.data.aggs[fields[i]].range.ranges[1].displayName = "n >= " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[1].from = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[2] = {};
                			obj.data.aggs[fields[i]].range.ranges[2].displayName = "n = " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[2].from = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[2].to = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[2].toIncl = true;
                			obj.data.aggs[fields[i]].range.ranges[3] = {};
                			obj.data.aggs[fields[i]].range.ranges[3].displayName = sas.fscf.floatFormatter.format(froms[i]) + " <= n <= " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[3].from = froms[i];
                			obj.data.aggs[fields[i]].range.ranges[3].to = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[3].toIncl = true;
                			obj.data.aggs[fields[i]].range.ranges[4] = {};
                			obj.data.aggs[fields[i]].range.ranges[4].displayName = sas.fscf.floatFormatter.format(froms[i]) + " < n <= " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[4].from = froms[i];
                			obj.data.aggs[fields[i]].range.ranges[4].fromIncl = false;
                			obj.data.aggs[fields[i]].range.ranges[4].to = tos[i];
                			obj.data.aggs[fields[i]].range.ranges[4].toIncl = true;
                			obj.data.aggs[fields[i]].range.ranges[5] = {};
                			obj.data.aggs[fields[i]].range.ranges[5].displayName = sas.fscf.floatFormatter.format(froms[i]) + " <= n < " + sas.fscf.floatFormatter.format(tos[i]);
                			obj.data.aggs[fields[i]].range.ranges[5].from = froms[i];
                			obj.data.aggs[fields[i]].range.ranges[5].to = tos[i];
                			var j = 6;
                			if (Math.abs(tos[i] - froms[i]) > 1) {
                				// skip this one if the difference between from and to is 1 as this
                				// would then be an invalid range that could not have any matches
                    			obj.data.aggs[fields[i]].range.ranges[j] = {};
                    			obj.data.aggs[fields[i]].range.ranges[j].displayName = sas.fscf.floatFormatter.format(froms[i]) + " < n < " + sas.fscf.floatFormatter.format(tos[i]);
                    			obj.data.aggs[fields[i]].range.ranges[j].from = froms[i];
                    			obj.data.aggs[fields[i]].range.ranges[j].fromIncl = false;
                    			obj.data.aggs[fields[i]].range.ranges[j].to = tos[i];
                    			j++;
                			}
                			obj.data.aggs[fields[i]].range.ranges[j] = {};
                			obj.data.aggs[fields[i]].range.ranges[j].displayName = "n = " + sas.fscf.floatFormatter.format(froms[i]);
                			obj.data.aggs[fields[i]].range.ranges[j].from = froms[i];
                			obj.data.aggs[fields[i]].range.ranges[j].to = froms[i];
                			obj.data.aggs[fields[i]].range.ranges[j].toIncl = true;
                			j++;
                			obj.data.aggs[fields[i]].range.ranges[j] = {};
                			obj.data.aggs[fields[i]].range.ranges[j].displayName = "n <= " + sas.fscf.floatFormatter.format(froms[i]);
                			obj.data.aggs[fields[i]].range.ranges[j].to = froms[i];
                			obj.data.aggs[fields[i]].range.ranges[j].toIncl = true;
                			j++;
                			obj.data.aggs[fields[i]].range.ranges[j] = {};
                			obj.data.aggs[fields[i]].range.ranges[j].displayName = "n < " + sas.fscf.floatFormatter.format(froms[i]);
                			obj.data.aggs[fields[i]].range.ranges[j].to = froms[i];        				
            			}
        			}
        			if (!(isNaN(g_froms[i]) && isNaN(g_tos[i]))) {
	           			var _g_from = g_froms[i];
	           			var _g_to;
	           			var j;
	           			while ((_g_from < g_tos[i]) || ((g_froms[i] == g_tos[i]) && (_g_from <= g_tos[i]))) {
	           				j = obj.data.aggs[fields[i]].range.ranges.length;
	               			obj.data.aggs[fields[i]].range.ranges[j] = {};
	               			_g_to = _g_from + ((g_bys[i] > 0) ? g_bys[i] : 100);	// g_by has to be > 0; if <= 0, use 100
	               			obj.data.aggs[fields[i]].range.ranges[j].displayName = sas.fscf.floatFormatter.format(_g_from) + " - " + sas.fscf.floatFormatter.format(_g_to);
	               			obj.data.aggs[fields[i]].range.ranges[j].from = _g_from;
	               			obj.data.aggs[fields[i]].range.ranges[j].to = _g_to;
	               			_g_from = _g_to;
	           			}
        			}
        		} else {
        			obj.data.aggs[fields[i]].terms = {};        			
        			obj.data.aggs[fields[i]].terms.field = fields[i];
        		}        		
        	}
        	return obj;
        };
		sas.fscf.getQueryUrlFromRuleModel = function(type, schema, overrideFields) {
        	// type should be "search"
        	if (type == undefined || type == null) {
        		type = "search";		// default to "search"
        	}
        	var ret = sas.fscf.getQueryUriComponentsFromRuleModel();
        	var urlSegments = [];
        	urlSegments[urlSegments.length] = "rest/transactions/" + type + "?";
        	if (schema != null && schema != undefined) {
            	urlSegments[urlSegments.length] = "schema=" + encodeURIComponent(schema);
        		try {
        			urlSegments[urlSegments.length] = "&tsperiod=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsperiod());        		
        		} catch (e) {}
        		try {
        			if (sas.fscf.getCurrentPageView().getGuidedView().getTsoffset()) {
        				urlSegments[urlSegments.length] = "&tsoffset=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsoffset());
        			}
        		} catch (e) {}
            	urlSegments[urlSegments.length] = "&";
        	}
        	urlSegments[urlSegments.length] = "q=";
    		var ruleOverallType = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition.type;
    		if (ruleOverallType == "OR") {
    			urlSegments[urlSegments.length] = encodeURIComponent(ret.qsegments.join(" OR "));
    		} else if (ruleOverallType == "NOR") {
       			urlSegments[urlSegments.length] = "*:* NOT (" + encodeURIComponent(ret.qsegments.join(" OR ")) + ")";
    		} else {
    			urlSegments[urlSegments.length] = encodeURIComponent(ret.qsegments.join(" AND "));
    		}
        	if ((overrideFields == null || overrideFields == undefined) && (ret.fields.length > 0)) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(ret.fields.join(","));
        	} else if (overrideFields.length > 0) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(overrideFields.join(","));
        	}
        	if (schema == null || schema == undefined) {
	        	urlSegments[urlSegments.length] = "&name=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.transactionTypeId);
	        	urlSegments[urlSegments.length] = "&scope=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId);
        	}
        	return urlSegments.join("");
        };
        sas.fscf.getQueryUriComponentsFromRuleModel = function() {
    		var ruleModel = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition;
    		var exps = ruleModel["expressions"];

    		var exp;
    		var ret;
    		var fields = [];
    		var qsegments = [];
        	for (var i = 0; i < exps.length; i++) {
        		exp = exps[i];
        		if (exp.type == "AND" || exp.type == "OR" || exp.type == "NOR") {
        			ret = sas.fscf.processGroupForQuery(exp);
        		} else {
        			ret = sas.fscf.processExpressionForQuery(exp);
        		}
        		if (ret) {
        			$.merge(fields, ret.fields);
        			if (ret.qsegment) {
               	    	qsegments[qsegments.length] = ret.qsegment;
        			}
        		}
        	}
        	var uniqueFields = [];
        	$.each(fields, function(i, el){
        	    if ($.inArray(el, uniqueFields) === -1) uniqueFields.push(el);
        	});
        	if (qsegments.length == 0) {
       	    	qsegments[qsegments.length] = "*:*";  // all
        	}
        	return {qsegments: qsegments, fields: uniqueFields};
        };
        sas.fscf.quoteSafeValue = function(value) {
        	// put double-quotes around the value so that certain special characters 
        	// such as spaces, forward-slashes, asterisks, etc. will work
        	return "\"" + value + "\"";
        };
        sas.fscf.escapeSafeValue = function(value) {
        	// put backslashes before certain special characters 
        	// such as spaces, forward-slashes, asterisks, ampersands, question marks and pound signs
        	return value.replace(/ /g, "\\ ").replace(/\//g, "\\/").replace(/\*/g, "\\*").replace(/&/g, "\\&").replace(/\?/g, "\\?").replace(/\#/g, "\\#");
        };
        sas.fscf.processExpressionForQuery = function(exp) {
        	if (!(exp.type == "AND" || exp.type == "OR" || exp.type == "NOR")) {
            	var fields = [];
            	var qsegment = "";
            	var value = exp.value;
        		fields[fields.length] = exp.fieldName;
        		qsegment += "(" + exp.fieldName + ":";

				if (exp.type == "RANGE") {
            		if (exp.leftOperator == "LT") {
            			qsegment += "{";
            		} else {
            			qsegment += "[";
            		}
            		qsegment += exp.leftValue;
            		qsegment += " TO ";
            		qsegment += exp.rightValue;
            		if (exp.rightOperator == "LT") {
            			qsegment += "}";
            		} else {
            			qsegment += "]";
            		}
            		qsegment += ")";
            	} else {
            		if( sas.fscf.isMultivalueOperator( exp.operator ) ) {
            			value = exp.values;
            		}
            		
            		qsegment = sas.fscf.getQueryForOperator( exp.operator, exp.fieldName, value, exp.fieldType );
            	}

    			return {fields: fields, qsegment: qsegment};
        	}
        };
        sas.fscf.processGroupForQuery = function(exp) {
        	if (exp.type == "AND" || exp.type == "OR" || exp.type == "NOR") {
        		var exps = exp.expressions;
        		if (!exps) {
        			return {fields: [], qsegment: null};
        		}
        		var subexp;
        		var ret;
            	var fields = [];
            	var qsegment = "";
            	var qsegments = [];
            	for (var i = 0; i < exps.length; i++) {
            		subexp = exps[i];
        			ret = sas.fscf.processExpressionForQuery(subexp);
            		if (ret) {
            			$.merge(fields, ret.fields);
               	    	qsegments[qsegments.length] = ret.qsegment;
            		}
            	}
    			qsegment = "(";
    			if (exp.type == "NOR") {
    				qsegment += "*:* NOT (";
    				qsegment += qsegments.join(" OR ");
    				qsegment += ")";

    			} else {
    				qsegment += qsegments.join(" " + exp.type + " ");
    			}
    			qsegment += ")";
    			return {fields: fields, qsegment: qsegment};
        	}
        };
        sas.fscf.startInFormView= function(view) {
        	view.setBusyIndicatorDelay(500).setBusy(true);
    		// start in form view
    		view.toggleFormView(true);
        	var form = view.getForm();
    		setTimeout(function () {
        		sap.ui.getCore().byId(view.sId + "ToolbarFormViewButton").setPressed(true);
        		form.somethingChangedInFullForm();
    			sas.fscf.getCurrentPageView().setDirty(false);
    	    	view._bDirtySinceLastFormView = true;
            	view.setBusy(false);
    		}, 300);
        };
        sas.fscf.loadRule= function(view) {
        	
        	view.setBusyIndicatorDelay(500).setBusy(true);
        	if (sas.fscf.ruleApproach == sas.fscf.RULE_APPROACH_GUIDED) {
            	var grid = view.getGrid();
            	var form = view.getForm();
            	if (sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties &&
               		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.view &&
               		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.view == "form") {
            		// start in form view
            		view.toggleFormView(true);
            		setTimeout(function () {
                		sap.ui.getCore().byId(view.sId + "ToolbarFormViewButton").setPressed(true);
                		form.somethingChangedInFullForm();
            			sas.fscf.getCurrentPageView().setDirty(false);
            	    	view._bDirtySinceLastFormView = true;
                    	view.setBusy(false);
            		}, 300);
                	return;
               	}
            	// start in grid view
            	var relatedRows = view.getRelatedRows();
            	relatedRows.update();
            	var oPanel;
            	var lbox;
            	var condition = null;
            	try {
            		condition = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition;
            	} catch (ex) {
            		condition = null;
            	}
            	if (condition) {
            		var exps = condition.expressions;
            		if (exps && exps.length > 0) {
                    	var panelData = {};
                    	try {
                    		panelData = JSON.parse(sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.panelData);
                    	} catch (ex) {
                    		panelData = {};
                    	}
                		sas.fscf.loadExpression(view, view.getGrid().getContent()[0], "", panelData, exps, 0, 0);
            		} else {
                    	view.setBusy(false);
            		}
            	} else {
                	view.setBusy(false);
            	}
        	} else {	//sas.fscf.RULE_APPROACH_CODING
        		view.setInit(true);
                view.setBusy(false);        		
        	}
        };
        sas.fscf.loadExpression = function(view, parentHLayout, parentId, panelData, exps, expi, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi) {
        	var grid = view.getGrid();
        	var palette = view.getPalette();
        	if (level == null || level == undefined) {
        		level = 0;
        	}
    		var exp = exps[expi];
    		if (exp) {
				var min, max, from, to, g_from, g_to, g_by = null;
				var overrideGroupBy = true;		// could be opening a rule from a prior version with no panelData, in which case default numerics to ungrouped
				if (panelData[exp.id]) {
					overrideGroupBy = !panelData[exp.id].groupBy;
					if (overrideGroupBy) {
						from = panelData[exp.id].from;
						to = panelData[exp.id].to;
					} else {
						g_from = panelData[exp.id].g_from;
						g_to = panelData[exp.id].g_to;
						g_by = panelData[exp.id].g_by;
					}
				} else {
					// could be opening a rule from a prior version with no panelData, in which case default from and to the old way
    				if (exp.type == "RANGE") {
    					from = parseFloat(exp.leftValue);
    					to = parseFloat(exp.rightValue);
    				} else {
    					if ((exp.fieldType == "Numeric") || (exp.fieldType == "Currency")) {
    						from = parseFloat(exp.value);
    						to = from;
    					}
    				}
				}
    			if ((exp.type == "COMPARE" || exp.type == "RANGE") && !sas.fscf.isMultivalueOperator(exp.operator)) {
					if ((exp.fieldType == "Numeric") || (exp.fieldType == "Currency")) {
	    				var fi = palette.getFieldInfoForFieldId(exp.fieldId);
	    				if (fi) {
	    					min = fi.min;
	    					max = fi.max;
	    				}
					}
    				var not = ((exp.type == "COMPARE") && ( sas.fscf.isNegativeOperator( exp.operator ) ));
    				grid.addPanel(exp.id, parentHLayout, parentId, exp.fieldName.toUpperCase(), exp.fieldId, exp.fieldType, exp.operator, exp.value, min, max, from, to, g_from, g_to, g_by, not, overrideGroupBy, function() {
    					// success callback
    	        		var lbox = grid.getListBoxForPanel(this);
    	                grid.selectListBoxItemFromExp(true, lbox, exp);
    					sas.fscf.loadExpression(view, parentHLayout, parentId, panelData, exps, expi + 1, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    				}, function () {
    	        		// failure callback
    	            	view.setBusy(false);
    	        	});
    			} else if (exp.type == "COMPARE" && sas.fscf.isMultivalueOperator(exp.operator)) {
    				var not = sas.fscf.isNegativeOperator( exp.operator );
    				grid.addPanel(exp.id, parentHLayout, parentId, exp.fieldName.toUpperCase(), exp.fieldId, exp.fieldType, exp.operator, exp.values, min, max, from, to, g_from, g_to, g_by, not, overrideGroupBy, function() {
    					// success callback
    	        		var lbox = grid.getListBoxForPanel(this);
		        		for (var j = 0; j < exp.values.length; j++) {
			        		for (var k = 0; k < lbox.getItems().length; k++) {
			        			if (lbox.getItems()[k].getKey() == exp.values[j]) {
									grid.selectListBoxItem(lbox, k);
									break;
			        			}
			        		}
		        		}
    					sas.fscf.loadExpression(view, parentHLayout, parentId, panelData, exps, expi + 1, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    				}, function () {
    	        		// failure callback
    	            	view.setBusy(false);
    	        	});
    			} else if ((exp.type == "OR") || (exp.type == "AND")) {
    				var subexps = exp.expressions;
    				var firstFieldId = subexps[0].fieldId;
    				var firstPanelData = panelData[subexps[0].id];
    				if (!firstPanelData) {
    					firstPanelData = panelData[exp.id];
    				}
    				var currentPanelData;
    				var bAllSameField = true;
    				for (var i = 0; i < subexps.length; i++) {
    					// to collapse to single list with multiselect, must be all same field, all same panel data and OR for numeric or currency,
    					// and all equals operator with OR or all not equals operator with AND for non-numeric and non-currency
    					if (subexps[i].fieldId != firstFieldId) {
    						bAllSameField = false;
    						break;
    					}
    					if ((subexps[i].fieldType == "Numeric") || (subexps[i].fieldType == "Currency")) {
    	    				currentPanelData = panelData[subexps[i].id];
    	    				if (!currentPanelData) {
    	    					currentPanelData = panelData[exp.id];
    	    				}
    						if ((exp.type == "AND") ||
    							!firstPanelData ||
    							!currentPanelData ||
    							(currentPanelData.groupBy != firstPanelData.groupBy)) {
        						bAllSameField = false;
        						break;     							
    						}
    						if (currentPanelData.groupBy) {
        						if ((currentPanelData.g_from != firstPanelData.g_from) ||
        							(currentPanelData.g_to != firstPanelData.g_to) ||
        							(currentPanelData.g_by != firstPanelData.g_by)) {
            						bAllSameField = false;
            						break;     							
        						}
    						} else {
        						if ((currentPanelData.from != firstPanelData.from) ||
           							(currentPanelData.to != firstPanelData.to)) {
               						bAllSameField = false;
               						break;     							
           						}
    						}
    					} else {
     						if (((exp.type == "OR") && (subexps[i].operator != sas.fscf.operators.EQUAL )) ||
     							((exp.type == "AND") && (subexps[i].operator != sas.fscf.operators.NE ))) {
        						bAllSameField = false;
        						break;     							
     						}
    						
    					}
    				}
    				if (bAllSameField) {
    					var id = exp.id;
    					exp = subexps[0];
    					if ((exp.fieldType == "Numeric") || (exp.fieldType == "Currency")) {
    	    				var fi = palette.getFieldInfoForFieldId(exp.fieldId);
    	    				if (fi) {
    	    					min = fi.min;
    	    					max = fi.max;
    	    				}
    					}
        				var not = ((exp.type == "COMPARE") && ( sas.fscf.isNegativeOperator( exp.operator ) ));
    					grid.addPanel(id, parentHLayout, parentId, exp.fieldName.toUpperCase(), exp.fieldId, exp.fieldType, exp.operator, exp.value, min, max, firstPanelData.from, firstPanelData.to, firstPanelData.g_from, firstPanelData.g_to, firstPanelData.g_by, not, !firstPanelData.groupBy, function() {
    						// success callback
    		        		var lbox = grid.getListBoxForPanel(this);
    		        		for (var j = 0; j < subexps.length; j++) {
    			        		for (var k = 0; k < lbox.getItems().length; k++) {
    			        			if ((((subexps[j].fieldType == "Numeric") || (subexps[j].fieldType == "Currency")) && (lbox.getItems()[k].getKey() == view.getGrid().getRangeForExp(subexps[j]))) || 
    			        				(lbox.getItems()[k].getKey() == subexps[j].value)) {
    									grid.selectListBoxItem(lbox, k);
    									break;
    			        			}
    			        		}
    		        		}
    						sas.fscf.loadExpression(view, parentHLayout, parentId, panelData, exps, expi + 1, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    					}, function () {
    		        		// failure callback
    		            	view.setBusy(false);
    		        	});
    				} else {
    					var oPanel = grid.addGroup(exp.id, parentHLayout, parentId, exp.type);
    					sas.fscf.loadExpression(view, sap.ui.getCore().byId(oPanel.sId + "_HorizLayout"), oPanel._pId, panelData, subexps, 0, level + 1, parentHLayout, parentId, exps, expi);
    				}
    			} else if (exp.type == "NOR") {
    				var oPanel = grid.addGroup(exp.id, parentHLayout, parentId, exp.type);
    				var subexps = exp.expressions;
    				sas.fscf.loadExpression(view, sap.ui.getCore().byId(oPanel.sId + "_HorizLayout"), oPanel._pId, panelData, subexps, 0, level + 1, parentHLayout, parentId, exps, expi);
    			} else {
    				sas.fscf.loadExpression(view, parentHLayout, parentId, panelData, exps, expi + 1, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    			}
    		} else {
    			if (level == 0) {
    	    		grid.updateCounts(null, function () {
    	        		// success callback
    	            	view.setBusy(false);
    	    		}, function () {
    	        		// failure callback
    	            	view.setBusy(false);
    	    		});
    			} else {
    				// go back up a level
    				sas.fscf.loadExpression(view, prior_parentHLayout, prior_parentId, panelData, prior_exps, prior_expi + 1, level - 1);
    			}
    		}
        };
        
        //puts the lookup lists keyed on keyField into the dropdown list for comboBox
        //selects the list with the name value if one exists, otherwise nothing is selected
        sas.fscf.getLookupListsForBox = function( comboBox, keyField, value ) {
        	
        	//remove items from the box
        	comboBox.removeAllItems();
        	
        	if( keyField == "" || keyField == undefined || keyField == null ) {
        		return;
        	}
        	
        	comboBox.setValue( value );
        	
        	var bu = sas.fscf.getCurrentPageView().jsonRule.businessUnitId;
        	sas.ajax({url:"rest/businessunits/" + bu + "/lookuplists", type:"GET", headers:sas.fscf.getAjaxHeaders()}).done(function (oData) {
        		//remove items from the box
            	comboBox.removeAllItems();
            	var numKeys;
            	
                for (var i = 0; i < oData.items.length; i++) {
                	
                	for( var j = 0; j < oData.items[i].columns.length; j++ ) {
                		
                		if( oData.items[i].columns[j].role == "KEY" && oData.items[i].columns[j].name.toUpperCase() === keyField.toUpperCase()
                      		  && oData.items[i].columns[j].dataType == "CHARACTER" ) {
                			
                			//problem: how to deal with lookup lists with multiple keys
                			//potential area for enhancement - use only one key of the list
                			//for now just discard lists with multiple keys
                			
                			numKeys = 0;
                			for( var k = 0; k < oData.items[i].columns.length; k++ ) {
                				if ( oData.items[i].columns[k].role == "KEY" )
                					numKeys++;
                			}
                			
                			//only add to the list if exactly 1 key
                			if( numKeys == 1 ) {
                			
                				comboBox.addItem(new sas.hc.ui.core.Item({
                					key: 'key' + i,
                					text: oData.items[i].name
                				}));
                			
                				//put the correct value in the box on load
                				if( oData.items[i].name == value )
                					comboBox.setSelectedKey( 'key' + i );
                			
                			}
                		}
                	}
                }
            });
        };
}