// The purpose of this class is to try to make maintaining or updating the operator list as painless as possible
// It should also help to separate view and logic, as currently Grid.view and Form.view do a lot of both
// There's some duplication between the two as well, so ideally they would both just come here instead
if (!sas.fscf.getOperators) {
	
	//all operators stored here
	sas.fscf.operators = {};
	sas.fscf.operators.EQUAL = "EQUAL";
	sas.fscf.operators.NE = "NE";
	sas.fscf.operators.GT = "GT";
	sas.fscf.operators.GTE = "GTE";
	sas.fscf.operators.LT = "LT";
	sas.fscf.operators.LTE = "LTE";
	sas.fscf.operators.IN = "IN";
	sas.fscf.operators.NOTIN = "NOTIN";
	sas.fscf.operators.MISSING = "MISSING";
	sas.fscf.operators.NOTMISSING = "NOTMISSING";
	sas.fscf.operators.SW = "SW";
	sas.fscf.operators.NOTSW = "NOTSW";
	sas.fscf.operators.SWANY = "SWANY";
	sas.fscf.operators.NOTSWANY = "NOTSWANY";
	sas.fscf.operators.EW = "EW";
	sas.fscf.operators.NOTEW = "NOTEW";
	sas.fscf.operators.EWANY = "EWANY";
	sas.fscf.operators.NOTEWANY = "NOTEWANY";
	sas.fscf.operators.CO = "CO";
	sas.fscf.operators.NOTCO = "NOTCO";
	sas.fscf.operators.COANY = "COANY";
	sas.fscf.operators.NOTCOANY = "NOTCOANY";
	//sas.fscf.operators.INLIST = "INLIST";
	//sas.fscf.operators.NOTINLIST = "NOTINLIST";
		
	
	sas.fscf.operatorList = [];
	//should have positive version immediately followed by negative version
	
	//equal operators
	sas.fscf.operatorList["EQUAL"] = [ sas.fscf.operators.EQUAL, sas.fscf.operators.NE ];
	
	//numeric operators
	sas.fscf.operatorList["NUMERIC"] = [ sas.fscf.operators.GT, sas.fscf.operators.GTE, sas.fscf.operators.LT, sas.fscf.operators.LTE ];
	
	//in operators
	sas.fscf.operatorList["IN"] = [ sas.fscf.operators.IN, sas.fscf.operators.NOTIN ];
	
	//missing operators
	sas.fscf.operatorList["MISSING"] = [ sas.fscf.operators.MISSING, sas.fscf.operators.NOTMISSING ];
	
	//filtering operators
	sas.fscf.operatorList["FILTERING"] = [ sas.fscf.operators.SW, sas.fscf.operators.NOTSW, sas.fscf.operators.EW, sas.fscf.operators.NOTEW, sas.fscf.operators.CO, sas.fscf.operators.NOTCO ];
	
	//in AND filtering operators
	sas.fscf.operatorList["INandFILTERING"] = [ sas.fscf.operators.SWANY, sas.fscf.operators.NOTSWANY, sas.fscf.operators.EWANY, sas.fscf.operators.NOTEWANY, sas.fscf.operators.COANY, sas.fscf.operators.NOTCOANY ];
	
	//lookup list operators
	//sas.fscf.operatorList["LOOKUPLIST"] = [ sas.fscf.operators.INLIST, sas.fscf.operators.NOTINLIST ];
	sas.fscf.operatorList["LOOKUPLIST"] = [];
	
	
	sas.fscf.getOperators = function() {	
		return sas.fscf.operatorList;
	};
	sas.fscf.getOperatorList = function() {
		var ops = sas.fscf.operatorList;
		var ret = [];
		ret = ret.concat(ops["EQUAL"], ops["NUMERIC"], ops["IN"], ops["MISSING"], ops["FILTERING"], ops["INandFILTERING"], ops["LOOKUPLIST"]);
		return ret;
	};
	sas.fscf.getOperatorListNonnumeric = function() {
		var ops = sas.fscf.operatorList;
		var ret = [];
		ret = ret.concat(ops["EQUAL"], ops["IN"], ops["MISSING"], ops["FILTERING"], ops["INandFILTERING"], ops["LOOKUPLIST"]);
		return ret;
	};
	
	//get specific types of operators
	sas.fscf.getEqualOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["EQUAL"];
	};
	sas.fscf.getNumericOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["NUMERIC"];
	};
	sas.fscf.getInOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["IN"];
	};
	sas.fscf.getMultivalueOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["IN"].concat( ops["INandFILTERING"] );
	};
	sas.fscf.getMissingOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["MISSING"];
	};
	sas.fscf.getValuelessOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["EQUAL"].concat( ops["IN"], ops["MISSING"] );
	};
	sas.fscf.getFilteringOperators = function() {
		var ops = sas.fscf.operatorList;
		var ret = ops["MISSING"];
		for( var i = 0; i < ops["FILTERING"].length-1 && i < ops["INandFILTERING"].length-1; i = i+2 ) {
			//put "starts with" next to "starts with any" and etc
			ret = ret.concat( ops["FILTERING"][i], ops["FILTERING"][i+1], ops["INandFILTERING"][i], ops["INandFILTERING"][i+1] );
		}
		return ret;
	};
	sas.fscf.getLookupListOperators = function() {
		var ops = sas.fscf.operatorList;
		return ops["LOOKUPLIST"];
	};
	//gets only the positive versions of the operators in the given array by removing every odd value (the negative operators)
	//must be provided an array of operators from one or multiple of the get*Operators functions to work properly
	sas.fscf.filterForPositiveOperators = function( ops ) {
		var ret = [];
		for( var i = 0; i < ops.length; i=i+2 ) {
			ret = ret.concat( ops[i] );
		}
		return ret;
	};
	//get all positive operators
	sas.fscf.getPositiveOperators = function() {
		return sas.fscf.filterForPositiveOperators( sas.fscf.getOperatorListNonnumeric() );
	};
	sas.fscf.getNegativeOperators = function() {
		//delete the first operator so it returns all the negative operators instead
		return sas.fscf.filterForPositiveOperators( sas.fscf.getOperatorListNonnumeric().slice(1) );
	};
	
	//check if given operator is a certain type
	sas.fscf.isEqualOperator = function( operator ) {
		var ops = sas.fscf.getEqualOperators();
		//apparently .includes is not supported in IE
    	//return ops.includes( operator );
    	return ops.indexOf( operator ) > -1;
	};
	sas.fscf.isInOperator = function( operator ) {
		var ops = sas.fscf.getInOperators();
    	//return ops.includes( operator );
		return ops.indexOf( operator ) > -1;
	};
	sas.fscf.isEqualOrInOperator = function( operator ) {
		var ops = sas.fscf.getEqualOperators().concat( sas.fscf.getInOperators() );
    	//return ops.includes( operator );
    	return ops.indexOf( operator ) > -1;
	};
	sas.fscf.isNumericOperator = function( operator ) {
		var ops = sas.fscf.getNumericOperators();
    	//return ops.includes( operator );
		return ops.indexOf( operator ) > -1;
	};
	sas.fscf.isMultivalueOperator = function( operator ) {
		var ops = sas.fscf.getMultivalueOperators();
    	//return ops.includes( operator );
		return ops.indexOf( operator ) > -1;
	};
	sas.fscf.isLookupListOperator = function( operator ) {
		var ops = sas.fscf.getLookupListOperators();
    	//return ops.includes( operator );
		return ops.indexOf( operator ) > -1;
	};
	sas.fscf.isFilteringOperator = function( operator ) {
		var ops = sas.fscf.getFilteringOperators();
    	//return ops.includes( operator );
		return ops.indexOf( operator ) > -1;
	};
    sas.fscf.isValuelessOperator = function( operator ) {
    	var ops = sas.fscf.getValuelessOperators();
    	//return ( operator == undefined || ops.includes( operator ) );
    	return operator == undefined || ops.indexOf( operator ) > -1;
    };
    sas.fscf.isMissingOperator = function( operator ) {
    	var ops = sas.fscf.getMissingOperators();
    	//return ops.includes( operator );
    	return ops.indexOf( operator ) > -1;
    };
    sas.fscf.isPositiveOperator = function( operator ) {
    	var ops = sas.fscf.getPositiveOperators();
    	//return ops.includes( operator );
    	return ops.indexOf( operator ) > -1;
    };
    sas.fscf.isNegativeOperator = function( operator ) {
    	var ops = sas.fscf.getNegativeOperators();
    	//return ops.includes( operator );
    	return ops.indexOf( operator ) > -1;
    };
    //operators that use NOT in their query - same as NegativeOperator except MISSING counts and NOTMISSING doesn't
    sas.fscf.isNotOperator = function( operator ) {
    	var ops = sas.fscf.getNegativeOperators();
    	for( var i = 0; i < ops.length; i++ ) {
    		if( ops[i] == sas.fscf.operators.NOTMISSING ) {
    			ops[i] = sas.fscf.operators.MISSING;
    			break;
    		}
    	}
    	//return ops.includes( operator );
    	return ops.indexOf( operator ) > -1;
    };
    
    //get positive, negative, inverted version of given operators
    sas.fscf.getNegativeOperator = function( operator ) {
    	var ops = sas.fscf.getOperatorListNonnumeric();
    	for( var i = 0; i < ops.length; i=i+2 ) {
    		if( ops[i] == operator )
    			return ops[i+1];
    	}
    	return operator;
    };
    sas.fscf.getPositiveOperator = function( operator ) {
    	var ops = sas.fscf.getOperatorListNonnumeric();
    	for( var i = 1; i < ops.length; i=i+2 ) {
    		if( ops[i] == operator )
    			return ops[i-1];
    	}
    	return operator;
    };
    sas.fscf.negateOperator = function( operator ){
    	var op = operator;
    	operator = sas.fscf.getNegativeOperator( operator );
    	if( op != operator )
    		return operator;
    	return sas.fscf.getPositiveOperator( operator );
    };
    
    //i would prefer to change the values in messagebundle.properties to where i could do like
    //sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators." + operator + ".txt");
    //but for now here's one extra place to write out all the operators as strings in a big list
    sas.fscf.localizedOperatorMap = [
		[ sas.fscf.operators.EQUAL,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.equals.txt") ],
		[ sas.fscf.operators.NE,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notEquals.txt") ],
		[ sas.fscf.operators.GT,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.greaterThan.txt") ],
		[ sas.fscf.operators.GTE,         sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.greaterThanOrEqualTo.txt") ],
		[ sas.fscf.operators.LT,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.lessThan.txt") ],
		[ sas.fscf.operators.LTE,         sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.lessThanOrEqualTo.txt") ],
		[ sas.fscf.operators.MISSING,     sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.missing.txt") ],
		[ sas.fscf.operators.NOTMISSING,  sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notMissing.txt") ],
		[ sas.fscf.operators.IN,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.in.txt") ],
		[ sas.fscf.operators.NOTIN,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notIn.txt") ],
		[ sas.fscf.operators.SW,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.startsWith.txt") ],
		[ sas.fscf.operators.NOTSW,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotStartWith.txt") ],
		[ sas.fscf.operators.SWANY,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.startsWithAny.txt") ],
		[ sas.fscf.operators.NOTSWANY,    sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotStartWithAny.txt") ],
		[ sas.fscf.operators.EW,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.endsWith.txt") ],
		[ sas.fscf.operators.NOTEW,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotEndWith.txt") ],
		[ sas.fscf.operators.EWANY,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.endsWithAny.txt") ],
		[ sas.fscf.operators.NOTEWANY,    sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotEndWithAny.txt") ],
		[ sas.fscf.operators.CO,          sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.contains.txt") ],
		[ sas.fscf.operators.NOTCO,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotContain.txt") ],
		[ sas.fscf.operators.COANY,       sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.containsAny.txt") ],
		[ sas.fscf.operators.NOTCOANY,    sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotContainAny.txt") ]
		//[ sas.fscf.operators.INLIST,      sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.isInList.txt") ],
		//[ sas.fscf.operators.NOTINLIST,   sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.isNotInList.txt") ]
	];

    sas.fscf.localizedOperatorMapVerbose = [
		[ "EQUAL", sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.equals.verbose.txt") ],
		[ "NE", sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notEquals.verbose.txt") ]
	];

    sas.fscf.getLocalizedOperator = function( operatorKey ) {
    	var arr = sas.fscf.localizedOperatorMap;
    	for( var i = 0; i < arr.length; i++ ) {
    		if ( arr[i][0] == operatorKey ) {
    			return arr[i][1];
    		}
    	}
    	return "";
    };
    sas.fscf.getLocalizedOperatorVerbose = function(operatorKey) {
    	var arr = sas.fscf.localizedOperatorMapVerbose;
    	for( var i = 0; i < arr.length; i++ ) {
    		if ( arr[i][0] == operatorKey ) {
    			return arr[i][1];
    		}
    	}
    	return sas.fscf.getLocalizedOperator( operatorKey );
    };
    sas.fscf.getOperatorKey = function( operatorText ) {
    	var arr = sas.fscf.localizedOperatorMap;
    	for( var i = 0; i < arr.length; i++ ) {
    		if ( arr[i][1] == operatorText ) {
    			return arr[i][0];
    		}
    	}
    	return "";
    };
    
    // operator = the operator ( ie, EQUAL, NE, etc)
    // fieldName = the field ( ie, AQO_ACCT_NUM, etc)
    // value = the selected value(s) on the panel
    // type = "Character", "Numeric", or "Currency"
    sas.fscf.getQueryForOperator = function( operator, fieldName, value, type ) {
    	if (value == undefined || value == null || ($.isArray(value) && value.length == 0)) {
    		if (!sas.fscf.isMissingOperator( operator )) {
        		return "";
    		}
    	}
    	
    	var isCharacter = ( type == "Character" );
    	
    	switch(operator) {
    	case sas.fscf.operators.EQUAL:
    	case sas.fscf.operators.IN:
    		if( !$.isArray( value ) ) {
    			if( isCharacter ) {
    				return "(" + fieldName +':"' + sas.fscf.escapeSafeValue(value) + '")';
    			} else {
    				//no quotes and dont escape
    				return "(" + fieldName +':' + value + ')';
    			}
    		} else {
    			var q = "(";
    			if( isCharacter ) {
    				for( var i = 0; i < value.length; i++ ) {
    					q += fieldName + ':"' + sas.fscf.escapeSafeValue( value[i] );
    					if( i + 1 < value.length ) {
    						q += '" OR ';
    					}
    				}
    				q += '"';
    			} else {
    				//no quotes and dont escape
    				for( var i = 0; i < value.length; i++ ) {
    					q += fieldName + ':' + value[i];
    					if( i + 1 < value.length ) {
    						q += ' OR ';
    					}
    				}
    			}
    			return q + ')';
    		}
    		break;
    	case sas.fscf.operators.NE:
    	case sas.fscf.operators.NOTIN:
    		var q = "(*:* NOT (";
    		if( !$.isArray( value ) ) {
    			if( isCharacter ) {
    				return q + fieldName +':"' + sas.fscf.escapeSafeValue(value) + '"))';
    			} else {
    				//no quotes and dont escape
    				return q + fieldName +':' + value + '))';
    			}
    		} else {
    			if( isCharacter ) {
    				for( var i = 0; i < value.length; i++ ) {
    					q += fieldName + ':"' + sas.fscf.escapeSafeValue( value[i] );
    					if( i + 1 < value.length ) {
    						q += '" OR ';
    					}
    				}
    			q += '"';
    			} else {
    				//no quotes and dont escape
    				for( var i = 0; i < value.length; i++ ) {
        				q += fieldName + ':' +  value[i] ;
        				if( i + 1 < value.length ) {
        					q += ' OR ';
        				}
        			}	
    			}
    			return q + '))';
    		}
    		break;
    	case sas.fscf.operators.LT:
    		return "(" + fieldName + ":" + "{* TO " + value +"})";
    		break;
    	case sas.fscf.operators.LTE:
    		return "(" + fieldName + ":" + "[* TO " + value +"])";
    		break;
    	case sas.fscf.operators.GT:
    		return "(" + fieldName + ":" + "{" + value +" TO *})";
    		break;
    	case sas.fscf.operators.GTE:
    		return "(" + fieldName + ":" + "[" + value +" TO *])";
    		break;
        case sas.fscf.operators.MISSING:
			return "(*:* NOT (" + fieldName + ":?*))";
            break;
        case sas.fscf.operators.NOTMISSING:
			return "(" + fieldName + ":?*)";
            break;
        case sas.fscf.operators.SW:
			return "(" + fieldName + ":" + sas.fscf.escapeSafeValue(value) + "*)";
            break;
        case sas.fscf.operators.NOTSW:
			return "( *:* NOT (" + fieldName + ":" + sas.fscf.escapeSafeValue(value) + "*))";
            break;
        case sas.fscf.operators.SWANY:
        	var ret = [];
        	for (var i = 0; i < value.length; i++) {
        		ret[ret.length] = "(" + fieldName + ":" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
        	}
			return "(" + ret.join(" OR ") + ")";
            break;
        case sas.fscf.operators.NOTSWANY:
        	var ret = [];
        	for (var i = 0; i < value.length; i++) {
        		ret[ret.length] = "(" + fieldName + ":" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
        	}
			return "( *:* NOT (" + ret.join(" OR ") + "))";
            break;
        case sas.fscf.operators.EW:
			return "(" + fieldName + ":*" + sas.fscf.escapeSafeValue(value) + ")";
            break;
        case sas.fscf.operators.NOTEW:
			return "( *:* NOT (" + fieldName + ":*" + sas.fscf.escapeSafeValue(value) + "))";
            break;
        case sas.fscf.operators.EWANY:
        	var ret = [];
        	for (var i = 0; i < value.length; i++) {
        		ret[ret.length] = "(" + fieldName + ":*" + sas.fscf.escapeSafeValue(value[i]) + ")"; 
        	}
			return "(" + ret.join(" OR ") + ")";
            break;
        case sas.fscf.operators.NOTEWANY:
        	var ret = [];
        	for (var i = 0; i < value.length; i++) {
        		ret[ret.length] = "(" + fieldName + ":*" + sas.fscf.escapeSafeValue(value[i]) + ")"; 
        	}
			return "( *:* NOT (" + ret.join(" OR ") + "))";
            break;
        case sas.fscf.operators.CO:
			return "(" + fieldName + ":*" + sas.fscf.escapeSafeValue(value) + "*)";
            break;
        case sas.fscf.operators.NOTCO:
			return "( *:* NOT (" + fieldName + ":*" + sas.fscf.escapeSafeValue(value) + "*))";
            break;
        case sas.fscf.operators.COANY:
        	var ret = [];
        	for (var i = 0; i < value.length; i++) {
        		ret[ret.length] = "(" + fieldName + ":*" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
        	}
			return "(" + ret.join(" OR ") + ")";
            break;
        case sas.fscf.operators.NOTCOANY:
        	var ret = [];
        	for (var i = 0; i < value.length; i++) {
        		ret[ret.length] = "(" + fieldName + ":*" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
        	}
			return "( *:* NOT (" + ret.join(" OR ") + "))";
            break;
        case sas.fscf.operators.INLIST:
        case sas.fscf.operators.NOTINLIST:
        default:
        	return "";
    	}
    };

}