sap.ui.jsview("sas.fscf.views.RulesPage", {
    getControllerName: function () {

    	return "sas.fscf.views.RulesPage";
    },
    
    _subViews: {},

    createContent: function(oController) {
       	jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
       	jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
        jQuery.sap.require("sas.hc.m.ResponsiveToolbar");
        jQuery.sap.require("sas.hc.m.ToolbarSpacer");
       	jQuery.sap.require("sas.hc.m.Select");
        jQuery.sap.require("sas.hc.m.Label");
        jQuery.sap.require("sas.hc.m.SearchField");

        var _this = this;
        var itemData = {
          		"items" : [
           		    		{
           		    			"key" : "Rules",
           		    			"name" : sas.fscf.rb.getText("rules.items.rules.txt"),
           		    			"enabled" : sas.fscf.userHasPrivilege("VIEWRULE")
           		    		},
           		    		{
           		    			"key" : "Estimations",
           		    			"name" : sas.fscf.rb.getText("rules.items.estimations.txt"),
           		    			"enabled" : sas.fscf.userHasPrivilege("UPDTRULE")
           		    		},
           		    		{
           		    			"key" : "LookupLists",
           		    			"name" : sas.fscf.rb.getText("rules.items.lookupLists.txt"),
           		    			"enabled" : sas.fscf.userHasPrivilege("UPDTRULE")
           		    		},
           		    		{
           		    			"key" : "Variables",
           		    			"name" : sas.fscf.rb.getText("rules.items.variables.txt"),
           		    			"enabled" : sas.fscf.userHasPrivilege("UPDTRULE")
           		    		},
           		    		{
           		    			"key" : "TransactionTypes",
           		    			"name" : sas.fscf.rb.getText("rules.items.transactionTypes.txt"),
           		    			"enabled" : sas.fscf.userHasPrivilege("UPDTRULE")
           		    		},
           		    		{
           		    			"key" : "Actions",
           		    			"name" : sas.fscf.rb.getText("rules.items.actions.txt"),
           		    			"enabled" : sas.fscf.userHasPrivilege("UPDTRULE")
           		    		}
           		 ]
        };
            
       	var itemsSelect = new sas.hc.m.Select({
       		id: this.sId + "ToolbarItemsSelect",
            tooltip: sas.fscf.rb.getText("rules.item.txt")
        });
       	itemsSelect.addStyleClass("cfFirstToolbarItem");
       	itemsSelect.setModel(new sap.ui.model.json.JSONModel(itemData));
       	itemsSelect.bindAggregation("items", {
           	path: "/items",
            factory: function(sId, oContext) {
                return new sas.hc.ui.core.ListItem(sId, {
               	  	key: oContext.getProperty("key"),
               	  	text: oContext.getProperty("name"),
               	  	enabled: oContext.getProperty("enabled")
                });
            }
        });

      	var cf_lastRulesItem = sas.fscf.getCookie("cf_lastRulesItem"); 
       	if (cf_lastRulesItem && itemsSelect.getItemByKey(cf_lastRulesItem) && itemsSelect.getItemByKey(cf_lastRulesItem).getEnabled()) {
           	itemsSelect.setSelectedKey(cf_lastRulesItem);
        } else {
          	cf_lastRulesItem = "Rules";
       		sas.fscf.setCookie("cf_lastRulesItem", cf_lastRulesItem, sas.fscf.getNYearsFromNow(1));
           	itemsSelect.setSelectedKey(cf_lastRulesItem);
       	}
       	itemsSelect.attachChange(function(oEvent) {
       		sas.fscf.removeAllMessageStrips();
      		sas.fscf.setCookie("cf_lastRulesItem", this.getSelectedItem().getKey(), sas.fscf.getNYearsFromNow(1));
      		if (this.getSelectedItem().getKey() == "Variables") {
       			_this.addWildBu();
       		} else {
       			_this.removeWildBu();
       		}
       		_this.update(this.getSelectedItem().getKey());
        });
        	
       	var buSelect = new sas.hc.m.Select({
       		id: this.sId + "ToolbarBUSelect",
            tooltip: sas.fscf.rb.getText("rules.businessUnit.txt")
        });
       	buSelect.addAriaLabelledBy(this.sId + "ToolbarBusinessUnitLabel");
        	
       	sas.ajax({url:'rest/businessunits', headers:sas.fscf.getAjaxHeaders()})
  		  .done(function(oData){
	
  			var model = new sap.ui.model.json.JSONModel(oData);
  			buSelect.setModel(model);
  			buSelect.bindAggregation("items", {
  	            path: "/items",
  	            factory: function(sId, oContext) {
  	                  return new sas.hc.ui.core.ListItem(sId, {
  	                	  key:  oContext.getProperty("id"),
  	                	  text: oContext.getProperty("name"),
  	                  });
  	            },
  	            sorter: new sap.ui.model.Sorter("name")
  	        });
  			if (cf_lastRulesItem == "Variables") {
  				_this.addWildBu();
  			}
	
          	var cf_lastRulesBU = sas.fscf.getCookie("cf_lastRulesBU"); 
          	if (cf_lastRulesBU && buSelect.getItemByKey(cf_lastRulesBU)) {
          		buSelect.setSelectedKey(cf_lastRulesBU);
          	} else {
        		sas.fscf.setCookie("cf_lastRulesBU", buSelect.getItems()[0].getKey(), sas.fscf.getNYearsFromNow(1));
        		sas.fscf.setCookie("cf_lastRulesBUName", buSelect.getItems()[0].getText(), sas.fscf.getNYearsFromNow(1));
          	}
  			buSelect.attachChange(function(oEvent) {
          		sas.fscf.removeAllMessageStrips();
        		sas.fscf.setCookie("cf_lastRulesBU", this.getSelectedItem().getKey(), sas.fscf.getNYearsFromNow(1));
        		sas.fscf.setCookie("cf_lastRulesBUName", this.getSelectedItem().getText(), sas.fscf.getNYearsFromNow(1));
  				if (sas.fscf.getCurrentOverviewToolbar()) {
  					sas.fscf.getCurrentOverviewToolbar().selectBU(this.getSelectedItem().getKey());
  				}
  				_this.updateSubViewTable();
  	    	});
  		  }).fail(function(oObj,textStatus){
  	         console.info("Failed to get business units.");
  		  });
        	
        var oSearch = new sas.hc.m.SearchField({
           	id: this.sId + "Search",
            placeholder: sas.fscf.rb.getText("rules.rulesPage.guidedView.search.txt")
        });
        oSearch.addStyleClass("cfRulesSearch cfLastToolbarItem");
        oSearch.attachSearch(function(oEvent){
       		sas.fscf.removeAllMessageStrips();
   			var subView = _this.getSubView(sas.fscf.getCookie("cf_lastRulesItem")); 
   			if (subView && subView.performSearch) {
   				subView.performSearch(oEvent.mParameters.query);
   			}
        });
            
        var oToolbar = new sas.hc.m.ResponsiveToolbar({
           	id: this.sId + "Toolbar",
       	    content: [
       	            itemsSelect,
       	      		new sas.hc.m.Label({
       	      			id: this.sId + "ToolbarBusinessUnitLabel",
       	                text: sas.fscf.rb.getText("rules.rulesPage.guidedView.businessUnit.txt")
       	    		}).addStyleClass("cfRulesBULabel"),
       	    		buSelect,
  			      	new sas.hc.m.ToolbarSpacer({
   					}),
       	    		oSearch
       	    ]
       	});

        var oBorderLayout = new sas.hc.ui.commons.layout.BorderLayout({
            id: this.sId + "BorderLayout",
       		top: new sas.hc.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutTop",
       			size: "2rem",
       			content: [
      			          oToolbar
       			]
       		}),
       	    center: new sas.hc.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutCenter",
       			content: [
       			          _this.getSubView(cf_lastRulesItem)
      			]
       		})
       	});

        return oBorderLayout;
    },
    
    addWildBu: function() {
   		var buSelect = sap.ui.getCore().byId(this.sId + "ToolbarBUSelect");
   		if (buSelect) {
   			if (!buSelect.getItemByKey("0")) {
   				var wildItem = new sas.hc.ui.core.Item({key: "0", text: sas.fscf.rb.getText("rules.businessUnits.wild.txt")});
   	   			buSelect.addItem(wildItem);   				
   			}
   		}
    },
    
    removeWildBu: function() {
   		var buSelect = sap.ui.getCore().byId(this.sId + "ToolbarBUSelect");
   		if (buSelect) {
   			if (buSelect.getItemByKey("0")) {
   				var bWasSelected = buSelect.getItemByKey("0") == buSelect.getSelectedItem(); 
   	   			buSelect.removeItem(buSelect.getItemByKey("0"));
   	   			if (bWasSelected) {
   	   	   			buSelect.setSelectedItem(null);		// select first item
   	        		sas.fscf.setCookie("cf_lastRulesBU", buSelect.getSelectedItem().getKey(), sas.fscf.getNYearsFromNow(1));
   	        		sas.fscf.setCookie("cf_lastRulesBUName", buSelect.getSelectedItem().getText(), sas.fscf.getNYearsFromNow(1));
   	   			}
   			}
   		}
    },
    
   	getSubView: function(item) {
   		var searchField = sap.ui.getCore().byId(this.sId + "Search");

   		if (item != "Rules" && item != "Estimations") {
   			item = "Legacy";
   			if (searchField.getVisible()) {
   				searchField.setVisible(false);
   			}
   		} else if (!searchField.getVisible()) {
   			searchField.setVisible(true);
   		}
   		if (!this._subViews[item]) {
   			this._subViews[item] = sap.ui.view({
                type: sap.ui.core.mvc.ViewType.JS,
                id: this.sId + item + "View",
                viewName: "sas.fscf.views.RulesPage" + item
            }); 
   		}
		return this._subViews[item];
	},
	
   	update: function(item) {
   		var oBorderLayout = sap.ui.getCore().byId(this.sId + "BorderLayout");
   		if (oBorderLayout) {
   	   		oBorderLayout.removeContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center, 0);
   	   		oBorderLayout.addContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center, this.getSubView(item));
   		}
		if (this.getSubView(item).update) {
			this.getSubView(item).update();
		}
	},

	updateSubViewTable: function() {
		var subView = this.getSubView(sas.fscf.getCookie("cf_lastRulesItem")); 
		if (subView && subView.updateTable) {
			subView.updateTable();
		}
	},
	
    _contentTypeMain: 'MAIN',
    _contentTypeGuided: 'GUIDED',
    _contentTypeCoding: 'CODING',
    _contentTypeEstimationResults: 'ESTIMATION_RESULTS',
    _contentType: this._contentTypeMain,

    switchToGuidedContent: function() {
    	if (this._contentType == this._contentTypeGuided) {
    		return;
    	}
    	this._mainContent = this.removeAllContent();
   		var guidedContent = [sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "GuidedView",
            viewName: "sas.fscf.views.RulesPageGuided"
        })];
    	for (var i = 0; i < guidedContent.length; i++) {
    		this.addContent(guidedContent[i]);
    	}
    	this._contentType = this._contentTypeGuided;
    },
    
	switchToCodingContent: function() {		
		
    	if (this._contentType == this._contentTypeCoding) {
    		return;
    	}
    	this._mainContent = this.removeAllContent();
   		var codingContent = [sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "CodingView",
            viewName: "sas.fscf.views.RulesPageCoding"
        })];
   		
    	for (var i = 0; i < codingContent.length; i++) {
    		this.addContent(codingContent[i]);
    	}
    	this._contentType = this._contentTypeCoding;
    },

    switchToMainContent: function() {
    	if (this._contentType == this._contentTypeMain) {
    		return;
    	}
    	this.setDirty(false);
        var toDestroy = this.removeAllContent();
    	for (var i = 0; i < toDestroy.length; i++) {
    		toDestroy[i]._destroyAll();
        	toDestroy[i].destroy();
    	}
    	for (var i = 0; i < this._mainContent.length; i++) {
        	this.addContent(this._mainContent[i]);
    	}
    	this.updateSubViewTable();
    	this._contentType = this._contentTypeMain;
    },

    switchContent: function (contentType, content) {
    	if (this._contentType == contentType) {
    		return;
    	}
    	this._mainContent = this.removeAllContent();
   		content.forEach(function (each) {
   			this.addContent(each);
   		}, this );
   		this._contentType = this._contentTypeEstimationResults;
    },
    
    switchToEstimationResultsContent: function (view) {
   		this.switchContent(this._contentTypeEstimationResults, [view]); 
    },
    
    initIdsForExpressions: function(baseId, exps) {
    	if (!exps) {
    		return;
    	}
    	var id;
		for (var i = 0; i < exps.length; i++) {
			if(exps[i]!=null){
				id = baseId + "-" + (i + 1);
				exps[i]["id"] = id;
				if ((exps[i]["type"] == "OR") || (exps[i]["type"] == "AND") || (exps[i]["type"] == "NOR")) {
					this.initIdsForExpressions(id, exps[i].expressions);
				}
			}
		}
    },

    getBUId: function() {
   		var buSelect = sap.ui.getCore().byId(this.sId + "ToolbarBUSelect");
   		if (buSelect) {
   			return buSelect.getSelectedKey();
   		}
    },
    
    getBUName: function() {
   		var buSelect = sap.ui.getCore().byId(this.sId + "ToolbarBUSelect");
   		if (buSelect) {
   			return buSelect.getSelectedItem().getText();
   		}
    },

    _bDirty: false,

    isDirty: function() {
    	return this._bDirty;
    },

    setDirty: function(bDirty) {
    	this._bDirty = bDirty;
    	if (this._contentType != this._contentTypeMain) {
    		this.getContent()[0]._dirtySet(bDirty);
    	}
    },


    getRulePropertiesDialog: function(isCodingApproach) {
        var view= sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "RulePropertiesDialog",
            fragmentName: "sas.fscf.views.fragments.RulePropertiesDialog"
        });
       
        view.setCodingApproach(isCodingApproach);
        return view.lazyLoadContent();
    },

    getPreviewRuleDialog: function() {
        return sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "PreviewRuleDialog",
            fragmentName: "sas.fscf.views.fragments.PreviewRuleDialog"
        });
    },

    getSearchTerm: function() {
    	var oSearch = sap.ui.getCore().byId(this.sId + "Search");
    	if (oSearch) {
    		return oSearch.getValue(); 
    	}
    	return undefined;
    },

    getGuidedView: function() {
    	return sap.ui.getCore().byId(this.sId + "GuidedView");
    },

    getCodingView: function() {
    	return sap.ui.getCore().byId(this.sId + "CodingView");
    }
});


