sap.ui.jsfragment("sas.fscf.views.fragments.AnalystListDialog", {

    _bExplore: false,
    _bAdd: true,

    isAdd: function() {
    	return this._bAdd;
    },

    setAdd: function(bAdd) {
    	this._bAdd = bAdd;
    },

    isExplore: function() {
    	return this._bExplore;
    },

    setExplore: function(bExplore) {
    	this._bExplore = bExplore;
    },

    getExploreContext: function() {
    	return this._oExploreContext;
    },

    setExploreContext: function(oExploreContext) {
    	this._oExploreContext = oExploreContext;
    },

	createContent: function(oController) {
	},
	
	lazyLoadContent: function() {
    	jQuery.sap.require("sas.hc.ui.commons.layout.VerticalLayout");
        jQuery.sap.require("sas.hc.m.CheckBox");

		var _this = this;
		var oVertLayout = new sas.hc.ui.commons.layout.VerticalLayout({
			id: this.sId + 'VertLayout',
			width: "100%"
		});
        var oDialog = new sas.hc.m.Dialog({
        	id: "AnalystListDialog",
        	title: _this.isAdd() ? sas.fscf.rb.getText('primaryTable.relatedRows.actions.AddToList.fmt.txt', _this.getExploreContext().txnId) : sas.fscf.rb.getText('primaryTable.relatedRows.actions.RemoveFromList.fmt.txt', _this.getExploreContext().txnId),
    	    content: [
    	              oVertLayout
    	    ],
    	    leftButton: new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('fcm.application.ok.txt'),
    	        press: function() {
    	        		var allSelected = _this.allSelected(oVertLayout);
    	        		if (allSelected && allSelected.length > 0) {
        	        		_this.updateNextList(oDialog, oVertLayout, allSelected, 0);
    	        		} else {
	        		  		sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText("explore.explorePage.guidedView.selectAList.txt"), oDialog.sId);    	        			
    	        		}
    	        }
    	    }),
    	    rightButton:  new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('rules.rulesPage.cancel.txt'),
    	        press: function() {
    	        	oDialog.close();
    	        }
    	    }),
    	    contentHeight: (window.innerHeight > 800 ? window.innerHeight * 0.4 : ((window.innerHeight > 700) ? window.innerHeight * 0.55 : window.innerHeight * 0.7)) + "px"
        });

		sas.ajax({url:"rest/analystlists?transactionId=" + _this.getExploreContext().txnId + "&transactionStorageType=" + _this.getExploreContext().txnAcronym, type: "GET", dataType:"json", headers:sas.fscf.getAjaxHeaders()})
	  	  .done(function(oData){
	  		  if (oData.items) {
	  			  var oCheckBox;
		  		  for (var i = 0; i < oData.items.length; i++) {
		  			  if (oData.items[i].analystAccessible) {
		  				  oCheckBox = new sas.hc.m.CheckBox({
			  	              id: oVertLayout.sId + "-CheckBox-" + oData.items[i].name,
			  	              name: oData.items[i].id,
			  	              text: oData.items[i].name,
			  	              selected: false
			  	          });
			  	          oVertLayout.addContent(oCheckBox);		  				  
		  			  }
		  		  }
		  		  if (oVertLayout.getContent().length == 0) {
					  sas.fscf.showMessageStrip(sap.ui.core.MessageType.Information, sas.fscf.rb.getText("explore.explorePage.guidedView.noAnalystListsAvailable.txt"), oDialog.sId);		  			  
		  		  }
	  		  } else {
				  sas.fscf.showMessageStrip(sap.ui.core.MessageType.Information, sas.fscf.rb.getText("explore.explorePage.guidedView.noAnalystListsAvailable.txt"), oDialog.sId);		  			  	  			  
	  		  }
		  }).fail(function(oObj,textStatus){
			  sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText("explore.explorePage.guidedView.getAnalystListsFailed.txt"), oDialog.sId);
		});		
		
        oDialog.attachAfterClose(function(oEvent) {
        	this.destroy();
        });

        return oDialog;
    },

    allSelected: function(oVertLayout) {
    	var allSelected = [];
    	for (var i = 0; i < oVertLayout.getContent().length; i++) {
       		if (oVertLayout.getContent()[i].getSelected()) {
       			allSelected[allSelected.length] = oVertLayout.getContent()[i]; 
       		}
		}
    	return allSelected;
    },
    
    updateNextList: function(oDialog, oVertLayout, allSelected, i) {
    	var _this = this;
    	oDialog.setBusyIndicatorDelay(0).setBusy(true);
    	if (allSelected[i]) {
   			sas.ajax({url:"rest/analystlists/" + allSelected[i].getName() + "/contents?transactionId=" + _this.getExploreContext().txnId + "&transactionStorageType=" + _this.getExploreContext().txnAcronym, type: (_this.isAdd()) ? "POST" : "DELETE", dataType:"json", headers:sas.fscf.getAjaxHeaders()})
   		  	  .done(function(oData){
   		  		  _this.updateNextList(oDialog, oVertLayout, allSelected, i + 1);
   			  }).fail(function(oObj,textStatus){
   			  	 oDialog.setBusy(false);
   				 var msg = sas.fscf.rb.getText(_this.isAdd() ? "explore.explorePage.guidedView.addToListFailed.fmt.txt" : "explore.explorePage.guidedView.removeFromListFailed.fmt.txt", allSelected[i].getText());
   				 if (oObj.responseJSON && oObj.responseJSON.message && oObj.responseJSON.message.length > 0) {
   					 msg += " " + oObj.responseJSON.message;
   				 }
 		  		 sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, msg, oDialog.sId);
   			});      	        		    	
    	} else {
    		// done
    		oDialog.close();      	        		  		  
	  		sas.fscf.showMessageStrip(sap.ui.core.MessageType.Success, _this.isAdd() ? sas.fscf.rb.getText("explore.explorePage.guidedView.addedToList.txt") : sas.fscf.rb.getText("explore.explorePage.guidedView.removedFromList.txt"), sas.fscf.getCurrentPageView().sId + "GuidedViewBorderLayoutCenter1");
    	}
    }
});
