<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<html>
<head>
<meta http-equiv="cache-control" content="no-cache" />
<title><fmt:message key="rules.sasLogContent.pageTitle.txt" /></title>
<style type="text/css">
body {margin: 8px;}
</style>
<script src="<c:url value="/common/scripts/i18n.js" />"></script>
<script src="<c:url value="/common/scripts/jquery.js" />"></script>
<script src="<c:url value="/rules/scripts/ruleSasTest.js" />"></script>
<script src="<c:url value="/rules/scripts/sas-log.js" />"></script>
</head>

<body onload="i18n.init(); showSasLogLoaded();" marginheight="0" marginwidth="0">
<form name="logForm" action="<c:url value="/r_ruleTester.do"/>" method="post">
  <%-- Input parms --%>
  <textarea name="sasCode" id="sasCode" style="display:none"></textarea>
  <input id="baseRuleId" name="baseRuleId" type="hidden" value=''/>
  <input id="ruleId" name="ruleId" type="hidden" value=''/>
  <input id="ruleTypeId" name="ruleTypeId" type="hidden" value=''/>
  <input id="transactionId" name="transactionId" type="hidden" value=''/>
  <input id="queueId" name="queueId" type="hidden" value=''/>
  <input id="alertType" name="alertType" type="hidden" value=''/>
  <input id="state" name="state" type="hidden" value=''/>
  <input id="checkoutUser" name="checkoutUser" type="hidden" value=''/>
  <input id="version" name="version" type="hidden" value=''/>
  <input id="slotId" name="slotId" type="hidden" value=''/>
  <input id="multiOrgId" name="multiOrgId" type="hidden" value=''/>
  <input id="debugFlag" name="debugFlag" type="hidden" value=''/>
  <input id="testModeFlag" name="testModeFlag" type="hidden" value='0'/> <!-- Unused -->
  <input id="earlyDate" name="earlyDate" type="hidden" value=''/>
  <input id="lateDate" name="lateDate" type="hidden" value=''/>
  <input id="account" name="account" type="hidden" value=''/>
  <input id="samplePercent" name="samplePercent" type="hidden" value=''/>
  <input id="sampleKey" name="sampleKey" type="hidden" value=''/>
  <input id="preReqs" name="preReqs" type="hidden" value=''/>
  <input id="executionOrderType" name="executionOrderType" type="hidden" value=''/>
  <input id="executionOrderPriority" name="executionOrderPriority" type="hidden" value=''/>
  <input id="estimateClassvars" name="estimateClassvars" type="hidden" value=''/>

  <%-- Input/Output parms --%>
  <input id="codeGenOnly" name="codeGenOnly" type="hidden" value='${codeGenOnly}'/>

  <%-- Output parms --%>
  <input id="preRequisites" name="preRequisites" type="hidden" value='${preRequisites}'/>
  <span id="weakRequisitesForDisplay" style="display:none;">
    <c:if test="${not empty logRule}">
     <tiles:insert page="tiles/weakDependency.jsp" flush="true">
       <tiles:put name="rule" beanName="logRule" />
       <tiles:put name="none" value="" />
     </tiles:insert>
    </c:if>
  </span>
  <span id="dependencySeparator" style="display:none;">
    <c:choose>
      <c:when test="${not empty logRule && not empty preRequisites && not empty logRule.weakDependencies}"><br></c:when>
      <c:when test="${    empty logRule || (   empty preRequisites &&     empty logRule.weakDependencies)}"><span class="softNone"><fmt:message key="rules.sasLogContent.noneValue.txt"/></span></c:when>
      <c:otherwise> </c:otherwise>
    </c:choose>
  </span>
  <input id="usedVariables" name="usedVariables" type="hidden" value='${usedVariables}'/>
  <input id="changedVariables" name="changedVariables" type="hidden" value='${changedVariables}'/>
  <input id="errorCount" name="errorCount" type="hidden" value='${errorCount}'/>
  <input id="warningCount" name="warningCount" type="hidden" value='${warningCount}'/>
  <input id="obsCount" name="obsCount" type="hidden" value='${obsCount}'/>
  <input id="resultsCount" name="resultsCount" type="hidden" value='${resultsCount}'/>

  <textarea name="generatedCode" id="generatedCode" style="display:none"><%-- ${generatedCode}--%>
  </textarea>
  <tt id='gutter' name='gutter' style="display:none;font-family:courier,serif;line-height:16px;">
   <c:forEach var="e" items="${errorLines}">
    <c:choose>
     <c:when test="${fn:startsWith(e,'ERROR')}"><img src="images/rules/reddot.gif"   height="10px" border="1" style="border-color:#f0f1f2;" onclick="alert(this.title)" onmouseover="this.style.cursor='pointer'" title="${esapi:encodeForHTMLAttribute(e)}"/></c:when>
     <c:when test="${fn:startsWith(e,'WARN')}"><img  src="images/rules/greendot.gif" height="10px" border="1" style="border-color:#f0f1f2;" onclick="alert(this.title)" onmouseover="this.style.cursor='pointer'" title="${esapi:encodeForHTMLAttribute(e)}"/></c:when>
    </c:choose>
    &nbsp;<br>
   </c:forEach>
  </tt>
</form>

<span id="actualSasLog">
<c:if test="${empty sasLog}">
    <center style="font-family:Arial;font-size:smaller">
      <br><br>
      <fmt:message key="rules.sasLogContent.notAvailable.txt" />
    </center>
</c:if>
</span>

<c:out value="${sasLog}" escapeXml="false" />

</body>
</html>
