<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2006, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/tiles/sasTabHeader.jsp
|DESCRIPTION: Tile containing the buttons and other controls at the top of the SAS tabs
|             of the rule detail screen
|---------------------------------------------------------------------------------------*/%>


<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%-- Access variables passed from caller --%>
<tiles:useAttribute name="prefix"  />
<tiles:useAttribute name="showSaveButton"/>
<tiles:useAttribute name="showSasRunButtons"/>
<tiles:useAttribute name="showEditorControls"/>
<tiles:useAttribute name="showBuilderControls"/>
<tiles:useAttribute name="showSubsetter"/>
<tiles:useAttribute name="showFinder"/>
<tiles:useAttribute name="showHistoryCheck"/>
<tiles:useAttribute name="showResultsControls"/>

<SCRIPT language="JavaScript">
//<!--
<c:if test="${showSubsetter}">
$(document).ready(function(){

	DateUtil.setDefaultDateFormat('${esapi:encodeForJavaScript(dateFormat)}');
   DateUtil.setMonthNames('${calendarMonthNames},${calendarShortMonthNames}'); <%-- do not html encode --%>
   DateUtil.setDayNames('${calendarFullDayNames},${calendarDayNames}'); <%-- do not html encode --%>
   DateUtil.setAmPmNames('${calendarAmPm}'); <%--  do not html encode --%>

	CalendarTime.setDateFormat('${esapi:encodeForJavaScript(dateFormat)}');
	CalendarTime.setMonthNames('${calendarMonthNames}'); <%-- do not html encode --%>
	CalendarTime.setDayNames('${calendarDayNames}'); <%-- do not html encode --%>
	CalendarTime.setShowMonthAfterYear(${esapi:encodeForJavaScript(calendarShowMonthAfterYear)});
	CalendarTime.setWeekStartDay(${esapi:encodeForJavaScript(calendarFirstDayOfWeek)});

	if ($("#${prefix}_calAnchor1").length==1) // RAPTOR-2399
	{
		var cal1 = CalendarTime.newPopup("${prefix}_calDiv1", "${prefix}_calAnchor1", "${prefix}_calTarget1",false,false);
		cal1.setCssPrefix("FCM");
		cal1.offsetX = -35;
		cal1.offsetY = 75;
		cal1.setReturnFunction(function(){$("#${prefix}_calTarget1").change();});
		$("#${prefix}_calAnchor1").click(function(){cal1.open();}).keydown(function(event){cal1.open(event);});
	}
	if ($("#${prefix}_calAnchor2").length==1) // RAPTOR-2399
	{
		var cal2 = CalendarTime.newPopup("${prefix}_calDiv2", "${prefix}_calAnchor2", "${prefix}_calTarget2",false,false);
		cal2.setCssPrefix("FCM");
		cal2.offsetX = -35;
		cal2.offsetY = 75;
		cal2.setReturnFunction(function(){$("#${prefix}_calTarget2").change();});
		$("#${prefix}_calAnchor2").click(function(){cal2.open();}).keydown(function(event){cal2.open(event);});
	}
});

// Position calendar object for date range
//var ${prefix}_calSubset = new CalendarPopup("${prefix}_calendarDIV1");
//${prefix}_calSubset.setCssPrefix("FCM");
//${prefix}_calSubset.offsetX = -35;
//${prefix}_calSubset.offsetY = 75;

</c:if>

// Identify draggable icons for code builder
var draggableIcons = [
  'filterIcon',
  'actionIcon',
  'filterActionIcon',
  'sasCodeIcon'
];

function setDefaultValue(o, formField, defaultValue)
{
	if (o.value=="")
		o.value = defaultValue;
	setTabValue(o,document,formField,o.value);
}

//-->
</SCRIPT>

<%-- Various styles show progress of draggables --%>
<STYLE>
</STYLE>



  <%-- Space --%>
  <tr class="configurationTableDataRow" valign="top"><td colspan="3" style="height:3px;"></td></tr>

  <tr class="configurationTableDataRow" valign="top">
    <td>&nbsp;</td>
    <td nowrap style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px" >
    <table border="0" width="100%" cellpadding="0" cellspacing="0">

      <%-- Line 1 of controls --%>
      <tr width="100%">

        <%-- Line 1, cell 1 --%>
        <td align="left" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" nowrap>
          <c:if test ="${showSubsetter}" >
            <fmt:message key="rules.rule.sasTabControl.rowsRange.limit.txt"/>&nbsp;
            <input id="${prefix}_obsCount_doNotDisable" name="${prefix}_obsCount" type="text" value="10" style="width:35px" onkeyup="setTabValue(this,document,'obsCount',this.value)"> <fmt:message key="rules.rule.sasTabControl.rowsRange.rows.txt"/>&nbsp;&nbsp;&nbsp;
          </c:if>
        </td>



        <%-- Line 1, cell 4 --%>
        <td align="left" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" nowrap >
        <c:if test ="${showSubsetter}" >
            <div id="${prefix}_calDiv1"  style="position:absolute;visibility:hidden;background-color:white;z-index:30"></div>
			<div id="${prefix}_calDiv2"  style="position:absolute;visibility:hidden;background-color:white;z-index:30"></div>
          	<input type="text" id="${prefix}_calTarget1" name="${prefix}_earlyDate" class="famTextEntry" value=<fmt:message key="rules.rule.sasTabControl.earliest.txt"/> style="width:100px" onChange="setDefaultValue(this,'earlyDate','<fmt:message key="rules.rule.sasTabControl.earliest.txt"/>')">
			<a href="#" id="${prefix}_calAnchor1">
				<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf198;"></span>
			</a>
            <fmt:message key="rules.rule.sasTabControl.rowsRange.to.txt"/>
            </td>

        <%-- Line 1, cell 5 --%>
            <td align="left" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" nowrap >
          	<input type="text" id="${prefix}_calTarget2" name="${prefix}_lateDate" class="famTextEntry" value=<fmt:message key="rules.rule.sasTabControl.latest.txt"/> style="width:100px" onChange="setDefaultValue(this,'lateDate','<fmt:message key="rules.rule.sasTabControl.latest.txt"/>')">
			<a href="#" id="${prefix}_calAnchor2">
				<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf198;"></span>
			</a>
        </c:if>
        </td>

        <%-- Line 1, cells 6 thru 10 (builder) --%>
        <c:if test ="${showBuilderControls}" >
          <td align="right"  valign="top" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" colspan="5" nowrap >
            <img id="filterIcon" src="images/rules/filter.gif" title="Transaction filter node" style="cursor:move;position:relative;"/>
            <img id="actionIcon" src="images/rules/action.gif" title="Action node" style="cursor:move;position:relative;"/>
            <img id="filterActionIcon" src="images/rules/filterAction.gif" title="Conditional action node" style="cursor:move;position:relative;"/>
            <img id="sasCodeIcon" src="images/rules/CustomSASCode.gif" title="Customized SAS code node" style="cursor:move;position:relative;"/>
            &nbsp;
            <img src="images/rules/stopButton.gif" width="2px" height="25px" style="margin-bottom:-5;"/>
            &nbsp;
            <img src="images/rules/FilingCabinet.gif" title="View code template library" style="cursor:pointer;"/>
            <img src="images/rules/stateTrash.gif" title="View recently deleted nodes" style="cursor:pointer;"/>
            &nbsp;
            <img src="images/rules/stopButton.gif" width="2px" height="25px" style="margin-bottom:-5;"/>
            &nbsp;
            <img src="images/rules/delete.gif" title="Delete selected item" style="cursor:pointer;"/>
            <img src="images/rules/edit.gif" title="Edit selected item" style="cursor:pointer;"/>
            <img src="images/rules/estimate0.gif" title="View SAS code for selected item" style="cursor:pointer;"/>
          </td>
        </c:if>

        <%-- Line 1, cells 6 thru 10 (non-builder) --%>
        <c:if test ="${not showBuilderControls}" >
          <%-- Line 1, cell 6 thru 7 --%>
          <td align="left" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px; width:3%;" colspan="1" nowrap >
            <c:if test ="${showSubsetter}">
              &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key="rules.rule.sasTabControl.sampleRule.sample.txt"/>:
              <input id="${prefix}_samplePercent_doNotDisable" name="${prefix}_samplePercent" type="text" value='1' style="width:35px;text-align:right;" maxlength='4' onkeyup="setTabValue(this,document,'samplePercent',this.value);"/>
              <fmt:message key="rules.rule.sasTabControl.sampleRule.by.txt"/>
              <select id="${prefix}_sampleKey_doNotDisable" name="${prefix}_sampleKey" style="display:;" onchange="setTabValue(this,document,'sampleKey',this.value);">
                 <option value=' '> <fmt:message key="rules.rule.sasTabControl.sampleRule.none.txt"/></option>
                 <c:forEach var="randomDigit" items="${randomDigitList}">
                   <option value="${randomDigit.name}" <c:if test="${randomDigit.name == defaultRandDigName}">selected="selected"</c:if>>${fn:escapeXml(randomDigit.label)}</option>
                 </c:forEach>
              </select>
            </c:if>
          </td>

          <%-- Line 1, cell 7 --%>
          <td align="right" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" nowrap >
          </td>

          <%-- Line 1, cell 8 --%>
          <td align="right" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" nowrap >
            <c:if test ="${showFinder}" >
              <span id="stackElementSizes" style="color:#efefef;"></span>&nbsp;<span id="undoStackSize" style="color:#efefef;"></span>&nbsp; <fmt:message key="rules.rule.sasTabControl.find.txt"/>:
            </c:if>
          </td>

          <%-- Line 1, cell 9 --%>
          <td align="left" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%" nowrap >
            <c:if test ="${showFinder}" >
            <input type="text" style="width:130px" id="${prefix}_stringToFind_doNotDisable" name="${prefix}_stringToFind" onkeyup="findString(this)" onclick="findString(this)">
              <span onclick="findCode('${prefix}')">
<%--              <img src="common/images/blank.gif" width="1" height="18"/>
              <img src="common/images/ArrowBlueDown.gif"
                   style="cursor:pointer"
                   title="<fmt:message key='rules.rule.sasTabControl.find.findNext.txt' />"
                   border="0" /> --%>
			  <span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons; cursor: pointer" data-sap-ui-icon-content="&#xf041;" title="<fmt:message key='rules.rule.sasTabControl.find.findNext.txt' />"></span>
              </span>
              <span onclick="findCode('${prefix}',true)">
<%--              <img src="common/images/blank.gif" width="1" height="18"/>
              <img src="common/images/ArrowBlueUp.gif"
                   style="cursor:pointer"
                   title="<fmt:message key='rules.rule.sasTabControl.find.findPrevious.txt' />"
                   border="0" /> --%>
			  <span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons; cursor: pointer" data-sap-ui-icon-content="&#xf047;" title="<fmt:message key='rules.rule.sasTabControl.find.findPrevious.txt' />"></span>
              </span>
            </c:if>
          </td>

          <%-- Line 1, cell 10 --%>
          <td align="left" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%" nowrap >
            <c:if test ="${showFinder}" >
            <span onClick="toggleButton(document.getElementById('match_case_button'),$i18n('rules.rule.sasTabControl.find.ignoreCase.txt'),$i18n('rules.rule.sasTabControl.find.matchCase.txt'));">
<%--              <img src="common/images/blank.gif" width="1" height="18"/>
              <img src="images/rules/IgnoreCase.gif"
                   style="cursor:pointer"
                   title="<fmt:message key='rules.rule.sasTabControl.find.matchCase.txt' />"
                   id="match_case_button"
                   border="0"/> --%>
			  <span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons; cursor: pointer; padding-left: 1px; margin-left: 4px; box-sizing: border-box" data-sap-ui-icon-content="&#xf0f7;" id="match_case_button" title="<fmt:message key='rules.rule.sasTabControl.find.matchCase.txt' />"></span>
            </span>
            </c:if>
          </td>
        </c:if>

      </tr>

<STYLE>
/* Override menu.js and cf.css style for reverse light-color tabber with header buttons */
.subtabs a {
	background:url("common/images/sTabLeft.gif") no-repeat left top;
}
.subtabs a span {
	background:url("common/images/sTabRight.gif") no-repeat right top;
}
</STYLE>

      <%-- Line 2 of controls --%>
      <tr width="100%">

        <%-- Line 2, cell 1 thru 3 --%>
        <td align="left"  valign="middle" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" colspan="1" nowrap >
          <c:if test ="${showHistoryCheck}" >

<!--      For now, do not allow selection of data to process
            <span style="display:none">
              <input type='checkbox' name='usingArchiveData' id='usingArchiveData_doNotDisable' checked="checked"
                     title="Check to process archived data instead of realtime data">
              Use archive data &nbsp;
            </span>
-->

            <!-- Used for testing estimation -->
            <input type='hidden' name='estimateClassvars' id='estimateClassvars_doNotDisable' width="100"
                   title="Enter columns to be used as class variables in impact estimation report.">
          </c:if>
          <c:if test ="${showEditorControls && not empty transactionLatestDate}" >
              <fmt:message key="rules.rule.sasTabControl.availableDates.txt"/>:
          </c:if>
        </td>

        <%-- Line 2, cell 4 --%>
        <td align="left"  valign="middle" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" colspan="1" nowrap >
          <c:if test ="${showEditorControls}" >
            &nbsp;<c:if test='${not empty transactionEarliestDate}'><fmt:formatDate value="${transactionEarliestDate}" type="date" dateStyle="long" pattern="${dateFormat}"/></c:if>
          </c:if>
        </td>

        <%-- Line 2, cell 5 --%>
        <td align="left"  valign="middle" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" colspan="1" nowrap >
          <c:if test ="${showEditorControls}" >
            &nbsp;&nbsp;<c:if test='${not empty transactionLatestDate}'><fmt:formatDate value="${transactionLatestDate}" type="date" dateStyle="long" pattern="${dateFormat}"/></c:if>
          </c:if>
        </td>

        <%-- Line 2, cell 6 --%>
        <td align="left"  valign="top" style="visibility:visible;padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:1%;" colspan="1" nowrap >
            <c:if test ="${showSubsetter}">
              &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key="rules.rule.sasTabControl.account.txt"/>:
              <input id="${prefix}_account_doNotDisable" name="${prefix}_account" type="text" value="" style="width:263px" onkeyup="setTabValue(this,document,'account',this.value);">
            </c:if>
        </td>

        <%-- Line 2, cell 7 thru 8 --%>
        <td align="right"  valign="middle" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:3%;" nowrap colspan="2">
          <c:if test ="${showEditorControls}" >
            &nbsp;&nbsp;<fmt:message key="rules.rule.sasTabControl.replace.txt"/>:
          </c:if>
        </td>

        <%-- Line 2, cell 9 --%>
        <td align="left"  valign="top" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:0px" nowrap>
          <c:if test ="${showEditorControls}" >
            <input type="text" style="width:130px" id="${prefix}_stringToSubstitute_doNotDisable" name="${prefix}_stringToSubstitute" >
            <span onclick="replaceCode('${prefix}',true);enableSaveButton(event);">
<%--            <img src="common/images/blank.gif" width="1" height="18"/>
            <img src="common/images/ArrowBlueDown.gif"
                 style="cursor:pointer"
                 title="<fmt:message key='rules.rule.sasTabControl.replace.findNext.txt' />"
                 border="0" /> --%>
			<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons; cursor: pointer" data-sap-ui-icon-content="&#xf041;" title="<fmt:message key='rules.rule.sasTabControl.replace.findNext.txt' />"></span>
            </span>
            <span onclick="replaceCode('${prefix}',true,true);enableSaveButton(event);">
<%--            <img src="common/images/blank.gif" width="1" height="18"/>
            <img src="common/images/ArrowBlueUp.gif"
                 style="cursor:pointer"
                 title="<fmt:message key='rules.rule.sasTabControl.replace.findPrevious.txt' />"
                 border="0" /> --%>
			<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons; cursor: pointer" data-sap-ui-icon-content="&#xf047;" title="<fmt:message key='rules.rule.sasTabControl.replace.findPrevious.txt' />"></span>
            </span>
          </c:if>
        </td>

        <%-- Line 2, cell 10 --%>
        <td align="left"  valign="top" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;width:0px" nowrap>
          <c:if test ="${showEditorControls}" >
            <span onclick="replaceCode('${prefix}');">
<%--            <img src="common/images/blank.gif" width="1" height="18"/>
            <img src="images/rules/equals.gif"
                 style="cursor:pointer"
                 title="<fmt:message key='rules.rule.sasTabControl.replace.highlighted.txt'/>"
                 id="replace_button"
                 border="0" /> --%>
			<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons; cursor: pointer; padding-left: 1px; margin-left: 4px; box-sizing: border-box" data-sap-ui-icon-content="&#xf005;" id="replace_button" title="<fmt:message key='rules.rule.sasTabControl.replace.highlighted.txt'/>"></span>
            </span>
          </c:if>
        </td>

      </tr>


    </table>
    </td>
    <td></td>
  </tr>




